#!/bin/sh
#
# Component: archive
#
# Description:
#  OBSOLETE [7.0]
#
#  Puts DICOM object to archive.
#
# Usage:
#   put.sh -s <study> -f <file> [-H <hostid>]
#
#    study  :  Study Instance UID
#    file   :  File name of DICOM object
#    hostid :  ID of the device the object was received from
#              commitment will be sent to hostid on successfull archiving
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

# if put.sh is called directly:
# run as a task instead
if [ `basename $0` = "put.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi


LOGGER="/usr/bin/logger"
TAG="archive/put[$$]"


# Parameters

INPUT_PARAMS=""
Study=""
File=""
Host=""

while getopts 'f:s:H:' OPT; do
	case $OPT in
		f) INPUT_PARAMS="$INPUT_PARAMS -f \"$OPTARG\"" ; File="$OPTARG" ;;
		s) INPUT_PARAMS="$INPUT_PARAMS -s \"$OPTARG\"" ; Study="$OPTARG" ;;
		H) INPUT_PARAMS="$INPUT_PARAMS -H \"$OPTARG\"" ; Host="$OPTARG" ;;
		*) ErrMsg="Invalid_Parameter:$OPT" ;;
	esac
done


# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	echo "@Archive @Archive-PUT"
}



run_()
{
	if [ -z "$File" -o -z "$Study" ] ; then
		$LOGGER -p $LOG_FACILITY.err -t "$TAG" "missing parameter(s)"
		return 125
	fi

	$TASKD_HOME/runjavacmd -c "0 archive.Put $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
}

# Override default cleanup_
# release reference counter
cleanup_()
{
	$TASKD_HOME/runjavacmd -c "cleanup archive.Put $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
}

# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print archive.Put $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
}

#
# Print value to be displayed on the WEB GUI
#
get_display_name_()
{
	echo "Put object to EP archive" 
}

#
# Print resources used by the task 
#
get_resources_()
{
	echo "System.NET.@Archive.PUT"
}

#
# Print property value
#
get_property_()
{
	if [ "$PROPERTY" = "1PST" ] ; then
		echo -n "$Study"
		return 0
	fi
	 
	if [ "$PROPERTY" = "1PPE" ] ; then
		echo -n "@Archive" 
		return 0
	fi

	get_def_property_
}
