#!/bin/bash
#
# Description:
#  Deletes the report of a study
#

ProgName=$( basename "$0" )
BaseDir=$( dirname $( readlink -f "$0" ) )

. $HOME/etc/setenv.sh

function usage_() {
	Tab=$'\t'
	cat <<-EOF
		${ProgName} [-h] -s <study> -r <reason> [-u <user>]
		${Tab}-h          : prints this help
		${Tab}-s <study>  : the study instance uid
		${Tab}-r <reason> : the reason for deleting the report
		${Tab}-u <user>   : the user deleting the report

		Deletes report of the study including external reports and dictation
	EOF
	
	[ -n "$1" ] && echo && echo "ERROR: $@" && exit 1
	exit 0
}


Study=""
Reason=""
User=""

while getopts ':hr:s:u:' OPT; do
	case ${OPT} in
		s) Study="$OPTARG" ;;
		r) Reason="$OPTARG" ;;
		u) User="$OPTARG" ;;
		h) usage_;;
		:) usage_ "Missing argument for option '-${OPTARG}'" ;;
		*) usage_ "Unrecognized option: '-${OPTARG}'" ;;
	esac
done

[ -z "${Study}" ] && usage_ "Missing mandatory option: -s <study>"
[ -z "${Reason}" ] && usage_ "Missing mandatory option: -r <reason>"


[ -f "$CONF/taskd.rc" ] && . $CONF/taskd.rc

Params="-s '${Study}' -r '${Reason}'"
[ -n "${User}" ] && Params="${Params} -u '${User}'"



#echo "0 cases.DeleteReport ${Params}" 
$TASKD_HOME/runjavacmd -c "0 cases.DeleteReport ${Params}"

exit $?

