<%--
 * Component: cases
 *
 * Description:
 *   Showing images/documents attached to a study
 *
 * Parameters:
 *   cStudy : [R] study instance UID of the study
 *   cBack  : [O] URL to go back 
 *	 cIntegrated : if true don't show tab bar or back button (used for report page integration)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.modules.gwt.session.BrowserInfo"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,
		java.sql.*,java.io.*,java.text.Format,java.util.*,imagemed.types.*, imagemed.types.string.*, imagemed.types.date.*,
		imagemed.dicom.*, imagemed.dotcom.DotcomConfig, imagemed.http.tabs.TabBean, imagemed.exception.*"

%>
<%@page import="com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl" %>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- Input Parameters --%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	BrowserInfo browserInfo = Helper.createBrowserInfo(request);


	boolean hasScanRight =  sess.getRights().hasRight( PacsRight.Scan );
	
	boolean isIntegrated = "true".equals( request.getParameter( "cIntegrated" ) );
	String study = request.getParameter( "cStudy" );
	String back = request.getParameter( "cBack" );
	if ( back == null )
		back = request.getHeader( "REFERER" );

	
	try {
		String redirHost = RedirectToolbox.getAttachmentRedirect( sess, study, RedirectToolbox.shouldForceSecure( request ) );
		if ( redirHost != null ) {
			response.sendRedirect( redirHost + "/cases/attachments.jsp?" + RedirectToolbox.getRedirectParams( sess, request ) );
			return;
		}
	}
	catch ( Throwable th ) {
		Helper.ERRORLOG( "cases/attachments.jsp", Helper.throwable2String( th ) );
	}
	
	
	String sourceStudy = study;
	String patientName = null;
	String studyDate = null;
	String modality = null;
	String orderNum = null;
	int mainStatus = -1;
	
	try ( ResultSet rs = IMEnv.getDB().prepareStatement( "SELECT PNAME, THEDATETIME, MODALITY, MAINST, SRCSTUDY from " + IMEnvBase.getEnv( "STUDYTBL" ) + " where STYIUID='" + study + "'" ).executeQuery() ) {
		if ( rs.next() ) {
			sourceStudy = rs.getString( "SRCSTUDY" );
			patientName = rs.getString( "PNAME" );
			mainStatus = rs.getInt( "MAINST" );
			studyDate = rs.getString( "THEDATETIME" );
			modality = rs.getString( "MODALITY" );
		}
	}

	if ( sourceStudy == null ) {
		sourceStudy = StudyToolbox.getSourceStudyDB( study );
	}
	
	patientName = IMTypePN.displayOrdinaryText(sess, patientName );
	studyDate = ((IMTypeDt) IMType.getTypeFor( "Dt" )).displayDateOnly(studyDate, sess );

	ViewAttachments viewAttachments = null;
	String orderId = null;
	boolean isUID = true;
	boolean isPACSorder = false;
	
	if ( mainStatus < 0 ) {
		orderId = study;
		if ( orderNum != null && !"".equals( orderNum ) ) {
			orderId = orderNum;
			isUID = false;
		}
		else {
			isPACSorder = true;
		}
		viewAttachments = new ViewAttachments( study, orderId, true, isUID );
	}
	else {
		orderId = sourceStudy;
		viewAttachments = new ViewAttachments( sourceStudy, sourceStudy, false, true );
	}

	AttachmentManager.LOCATION accessLocation = isIntegrated ? AttachmentManager.LOCATION.REPORTPANEL : AttachmentManager.LOCATION.ATTACHMENTS; 
	boolean hasAttachments = viewAttachments.collectAttachments( sess, accessLocation );

	String pageTitle = LocalizedMessage.getCompoundMessage( "ATTACHMENTS_OF", new Format[] { null }, new Object[] { patientName }, true ); 
	
%>
<%@page import="imagemed.dotcom.DotcomDevice"%><HTML><HEAD><TITLE><%= pageTitle %></TITLE>

	<STYLE type="text/css">

		a.scanlink {
			margin-left: 20px;
			margin-right: 20px;
		}

		img.thumbimage {
			max-width: 128px;
			max-height: 128px;
			vertical-align: middle;
			border: 1px;
			border-color: black;
		}

<% if ( isIntegrated ) { %>
		BODY {
			padding: 0px;
			margin: 0px;
		}

<% } %>

		td.thumbpanel {
			width: 100px;
			vertical-align: top;
			padding: 0px;
			height: 250px;
			margin-right: 1px;
		}

		td.selectedThumbnail {
			background-color: #0043c8;
			height: 70px;
			width: 70px;
			border-style: solid;
			border-width: 1px;
			border-color: blue;
			text-align: center;
		}

		td.thumbnail {
			height: 70px;
			width: 70px;
			border-style: solid;
			border-width: 1px;
			border-color: black;
			text-align: center;
		}

		td.viewArea {
			height: 100%;
			vertical-align: middle;
			text-align: center;
			border-width: 1px;
			border-style: solid;
			border-color: black;
			overflow: auto;
			margin-left: 1px;
		}
		
		td.moreless {
		   cursor: pointer;
		   height: 25px;
		   max-height: 35px;
		   text-align: center;
			border-style: solid;
			border-width: 1px;
			border-color: black;
		}

		#previewImg {
			display: none;
			position: absolute;
			left: 90px;
			border: 5px;
			border-style: ridge;
			border-color: Gray;
			max-width: 300px;
			max-height: 300px;
		}

		#previewDoc {
			display: none;
			position: absolute;
			left: 90px;
			top: 10px;
			border: 5px;
			border-style: ridge;
			border-color: Gray;
			max-width: 300px;
			max-height: 100px;
			width: 300px;
			padding: 10px;
			background-color: #e0e0e0;
		}

	</STYLE>


	<SCRIPT Language="JavaScript">
		var selectedThumbnail;

		var hiddenAtts = new Array();
		var morelessName = "asc";
		
		var moreTitle = "<%= LocalizedMessage.getSimpleMessage( "SHOW_HIDDEN_ATTACHMENTS" ) %>";
		var lessTitle = "<%= LocalizedMessage.getSimpleMessage( "HIDE_HIDDEN_ATTACHMENTS" ) %>";
		
		
		function switchTh( thid ) {
			var thumb = document.getElementById( thid );
			if ( !thumb ) {
				return false;
			}

			if ( selectedThumbnail != undefined ) {
				selectedThumbnail.className = "thumbnail";
			}

			thumb.className = "selectedThumbnail";
			selectedThumbnail = thumb;

			return true;
		}


	function showImage( thid, imgName ) {
		var imgObj = document.getElementById( 'viewFrame' );
		if ( !imgObj ) {
			return false;
		}

		if ( ! switchTh( thid ) ) {
			return false;
		}

		imgObj.src = "attachmentImage.jsp?imgName="+encodeURIComponent(imgName);//"";
		imgObj.focus();
	}

	function showDoc( thid, docName ) {
		var imgObj = document.getElementById( 'viewFrame' );
		if ( !imgObj ) {
			return false;
		}

		if ( ! switchTh( thid ) ) {
			return false;
		}

		imgObj.src = docName;
	}
	

	function showPreviewImage( img, src, fixWidth ) {
		var tmp = document.getElementById( 'thumbDiv' );
		var minTop = calcElementTop(tmp); // - tmp.scrollTop;
		var maxBottom = minTop + tmp.clientHeight;
		img.style.cursor = "pointer";
		var imgElem = document.getElementById( 'previewImg' );
		if ( fixWidth ) {
			imgElem.style.height = "auto";
			imgElem.style.width = "300px";
		}
		else {
			imgElem.style.width = "auto";
			imgElem.style.height = "300px";
		}

		imgElem.src = src;

		// The imgElem needs to be displayed before adjusting the position to get correct element height
		var top = calcElementTop( img ) + img.offsetHeight - tmp.scrollTop - 170;
		imgElem.style.top = top;
		imgElem.style.display = "block";
		
		// alert( "imgElem clientHeight: "+imgElem.clientHeight+"\noffsetHeight: "+imgElem.offsetHeight+"\nscrollHeight: "+imgElem.scrollHeight);
		// alert( "minTop: "+minTop+", maxBottom: "+maxBottom+", clientHeight: "+imgElem.clientHeight+", top: "+ top);

		if (top < minTop) {
			imgElem.style.top = minTop;
		}
		else if (top + imgElem.clientHeight > maxBottom) {
			// bottom - height - border
			imgElem.style.top = maxBottom - imgElem.clientHeight - 10;
		}
	}

	function hidePreviewImage( img ) {
		img.style.cursor = "auto";
		var imgElem = document.getElementById( 'previewImg' );

		imgElem.style.display = "none";
	}


	function showPreviewDoc( doc, content ) {
		doc.style.cursor = "pointer";
		var docElem = document.getElementById( 'previewDoc' );
		var thumbnailDiv = getelementbyid( 'thumbDiv' );
		docElem.style.top = ( calcElementTop(doc) + doc.offsetHeight - thumbnailDiv.scrollTop - 40 ) + 'px';
		
		docElem.style.display = "block";
		docElem.innerHTML = content;
	}

	function hidePreviewDoc( doc ) {
		doc.style.cursor = "auto";
		var docElem = document.getElementById( 'previewDoc' );

		docElem.style.display = "none";
		docElem.innerHTML = "";
	}
	
	function hideHiddens() {
		for ( var i = 0; i < hiddenAtts.length; i++ ) {
			<%if ( browserInfo.isMSIE(  ) ) {%>
				hiddenAtts[i].style.display = "none";
			<%} else {%>
				hiddenAtts[i].style.visibility = "collapse";
			<%}%>
		}
	}

	function showHiddens() {
		for ( var i = 0; i < hiddenAtts.length; i++ ) {
		<%if ( browserInfo.isMSIE(  ) ) {%>
			hiddenAtts[i].style.display = "inline";
		<%} else {%>
			hiddenAtts[i].style.visibility = "visible";
		<%}%>
		}
	}
	
	function initMoreLess() {
		var img = getelementbyid( "imgmoreless" );
		morelessName = "asc";
		img.src = "/cases/art/" + morelessName + suffix + ".gif";
		img.title = moreTitle;
	}
	
	function toggleMoreLess( img ) {
		var img = getelementbyid( "imgmoreless" );
		if ( 'asc' == morelessName ) {
			showHiddens();
			morelessName = "desc";
			img.title = lessTitle;
		}
		else {
			hideHiddens();
			morelessName = "asc";
			img.title = moreTitle;
		}
		img.src = "/cases/art/" + morelessName + suffix + ".gif";
	}

	
	// Shows document type info with edit in a hover over an html element
	//
	// @param event    mouseover event
	// @param elem     the element triggering the hover
	// @param attid    identifies the attachment 
	// @param doctype  document type of the attachment
	// @param atttype  attachment type (PACS (DICOM)/Scheduler)
	function showToolDiv( event, elem, attid, doctype, atttype ) {
		var toolDiv = getelementbyid( 'doctypetool' );
		var thumbnailDiv = getelementbyid( 'thumbDiv' );
		toolDiv.style.top = ( calcElementTop(elem) + elem.offsetHeight - thumbnailDiv.scrollTop - 25 ) + 'px';
		toolDiv.style.left = ( calcElementLeft( elem ) + 1 ) + 'px';
		toolDiv.style.visibility = "visible";
	
		document.doctypeForm.cAttName.value = attid;
		document.doctypeForm.cAttType.value = atttype;
		
		document.doctypeDeleteForm.cAttName.value = attid;
		document.doctypeDeleteForm.cAttType.value = atttype;
		
		var labelSpan = getelementbyid( 'doctypelabel' );
		if ( labelSpan ) {
			labelSpan.innerHTML = doctype;
		}

	}
	
	// Hides the document type hover 
	//
	function hideToolDiv() {
		var toolDiv = getelementbyid( 'doctypetool' );
		toolDiv.style.visibility = "hidden";
	}

	// Shows edit document type page in the preview pane 
	//
	function editDocType() {
		document.doctypeForm.submit();
	}
	
	function deleteDocType() {
		document.doctypeDeleteForm.submit();
	}


	// Reloads the page
	//
	function reloadPage() {
		document.reloadForm.submit();
	}
	
	/*
	 Reload page after image object is scanned for an order
	 Will redirect to the worklist page
	*/
	function reloadPageAfterStudyScan() {
		 setTimeout( "self.document.location='<%=back%>';", 1000 );
	}

	</script>
<%
	TabToolbox.writeIMpopup(out);
	TableImpl.printCommonScript(new PrintWriter(out));

%>
</HEAD>
<BODY>
<FORM name="reloadForm" action="attachments.jsp">
<INPUT type="hidden" name="cStudy" value="<%= Helper.htmlEncode( study ) %>" />
<INPUT type="hidden" name="cBack" value="<%= Helper.htmlEncode( back ) %>" />
<INPUT type="hidden" name="cIntegrated" value="<%= isIntegrated %>" />
</FORM>
<TABLE width="100%" border=0 cellpadding="0" cellspacing="0" style="height: 100%;">
<%
if ( !isIntegrated ) {
	String titleInfo = patientName + " - " + studyDate + " - " + modality;
	String title = LocalizedMessage.getCompoundMessage( "ATTACHMENTS_OF", new Format[] { null }, new Object[] { titleInfo }, true ); 
%>
<TR><TD>
<%
	TabToolbox.makeTabs( sess, null, "cases/index.jsp", "White" );
%>
<TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
	<TR><TD class=BgShadow width="100%">
		<TABLE border=0 cellpadding=0 cellspacing=0 width="100%"><TR>
 			<TD nowrap class=BgShadow style="padding: 15px 20px;">
				<font size=4><%= title %></font>
			</TD>
			<TD width="20%" nowrap align=left>
<%
	//SCAN stuff - only for non-link, non-orders
	if ( study.equals( sourceStudy ) && hasScanRight  ) {
		
		String type = AttachmentManager.getScanTargetType();
		String altJpg = LocalizedMessage.getSimpleMessage( "SCAN_JPG_ALT_TEXT" );
		String altPdf = LocalizedMessage.getSimpleMessage( "SCAN_PDF_ALT_TEXT" );
		String altUpload = LocalizedMessage.getSimpleMessage( "UPLOAD_ALT_TEXT" );
		String doctypeDefault = AttachmentManager.getDefaultDoctypeName( "DTAD" );
		String doctypeDefaultUpload = AttachmentManager.getDefaultDoctypeName( "DTAU" );

		if ( mainStatus >= 0 ) {
			if( !browserInfo.isLinux() && TabBean.hasLicense( imagemed.http.tabs.TabBean.LICENSE_SCAN ) ) {
				// scanning for studies
				if ( !AttachmentManager.SCANTO_PDF.equals( type ) ) {
					//scan into jpg button
					%><A class="scanlink" HREF="#" onclick="IMpopupSame( '/cases/preDicomScan.jsp?cStudyIUID=<%=study%>&cDoctypeDefault=<%=Helper.URLEncodeUTF8( doctypeDefault )%>', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%= JSHelper.getJsButton( browserInfo, "scanAsJPG", 24, 24, altJpg ) %></a><%
				}
				if ( !AttachmentManager.SCANTO_JPG.equals( type ) ) {
					//scan into pdf button
					%><A class="scanlink" HREF="#" onclick="IMpopupSame( '/cases/preDicomScan.jsp?cPDF=true&cStudyIUID=<%=study%>&cDoctypeDefault=<%=Helper.URLEncodeUTF8( doctypeDefault )%>', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( browserInfo, "scanAsPDF", 24, 24, altPdf ) %></a><%
				}
			}
			// upload button
			%><A class="scanlink" HREF="#" onclick="IMpopupCenter( '/cases/preDicomScan.jsp?cStudyIUID=<%=study%>&cDoctypeDefault=<%=Helper.URLEncodeUTF8( doctypeDefaultUpload )%>&cUploadOnly=true', 'PopUpScan', '<%=AttachmentManager.UPLOADWINDOW_WIDTH%>', '<%=AttachmentManager.UPLOADWINDOW_HEIGHT%>', 'scrollbars=auto, resizable=yes,'); return false;"><%= JSHelper.getJsButton( browserInfo, "uploadnew.png", 24, 24, altUpload ) %></a><%
		}
		else {
			// scanning for orders
			// only for the topmost device in the Single Enterprise				
			DotcomDevice selfDevice = DotcomConfig.selfDevice();
			if( selfDevice != null && selfDevice ==  DotcomConfig.getConfig().getTopMostDeviceInSingleEnterprise() ) { 
				String scanRedir = null;
				boolean needLink = true;
				try {
					scanRedir = RedirectToolbox.getOrderAttachmentRedirect( sess, sourceStudy );
					if ( scanRedir == null ) {
						scanRedir = "";
					}
				}
				catch ( IMException imEx ) {
					Helper.DEBUG( "scanLink", "No scan link is needed for order " + orderId + ": " + Helper.throwable2String( imEx ) );
					needLink = false;
				}
				if ( needLink ) {
					String scanURL = scanRedir + "/cases/prePACSOrderScan.jsp?id=" + Helper.URLEncodeUTF8( orderId ) + "&cStudyIUID=" + study + "&isUID=" + isUID;
					if( !browserInfo.isLinux() && TabBean.hasLicense( TabBean.LICENSE_SCAN ) ) {
						if( !AttachmentManager.SCANTO_PDF.equals( type ) ) {
							//scan into jpg button
							%><A class="scanlink" HREF="#" onclick="IMpopupSame( '<%=scanURL + "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) %>', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( browserInfo, "scanAsJPG", 24, 24, altJpg ) %></a><%
						}
						if( !AttachmentManager.SCANTO_JPG.equals( type ) ) {
							//scan into pdf button
							%><A class="scanlink" HREF="#" onclick="IMpopupSame( '<%=scanURL + "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) %>&cPDF=true', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( browserInfo, "scanAsPDF", 24, 24, altPdf ) %></a><%
						}
					}
					//upload button
					%> <A  class="scanlink" HREF="#" onclick="IMpopupCenter( '<%=scanURL + "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefaultUpload ) %>&cUploadOnly=true', 'PopUpScan', '<%=AttachmentManager.UPLOADWINDOW_WIDTH%>', '<%=AttachmentManager.UPLOADWINDOW_HEIGHT%>', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( browserInfo, "uploadnew.png", 24, 24, altUpload ) %></a><%
				}
			}
		}
	}
%>
			</TD>
			<TD class=BgShadow nowrap width="100%" align=right>
				<a style="margin-left: 30px; margin-right: 30px;" href="<%=back%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_BACK", "BUTTON_NULL", false ) %></a>
			</TD>
		</TR></TABLE>
	</TD></TR>
</TABLE>
</TD></TR>
<%}%>
<TR style="height: 100%;"><TD style="vertical-align: top;">

<%

	if ( !hasAttachments ) {
		out.println( "<BR><CENTER>" );
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "NO_ATTACHMENTS_TITLE" ), "60%" );
		mb.setMessage( LocalizedMessage.getSimpleMessage( "NO_ATTACHMENTS_MESSAGE" ) );
		mb.print( new PrintWriter(out) );
		
		out.println( "</CENTER></TD></TR></TABLE></BODY></HTML>" );
		return;
	}
%>


<TABLE border=0 width="100%" cellpadding=0 cellspacing=0 style="height: 100%; margin-top: 2px;">
	<TR>
		<TD class="thumbpanel">
			<DIV style="overflow: auto; height: 100%; text-align: left;" id="thumbDiv">
				<TABLE border=0 cellpadding=1 cellspacing=0 style="border-collapse: collapse;">
<%


	int thCounter = 0;
	Vector<ViewAttachments.AttachmentView> visibleViews = viewAttachments.getVisibleViews();
	for ( ViewAttachments.AttachmentView view : visibleViews ) {
		view.writeThumbnailTR( thCounter, false, out, browserInfo );
		thCounter++;
	}

	Vector<ViewAttachments.AttachmentView> hiddenViews = viewAttachments.getHiddenViews();
	if ( !hiddenViews.isEmpty() ) {
		out.print( "<TR><TD id=\"tdmoreless\" class=\"moreless BgMedDark\" onClick=\"toggleMoreLess();\">" );
		out.print( "<IMG id=\"imgmoreless\">" );
		out.println( "</TD></TR>" );
		out.println( "<SCRIPT language=\"JavaScript\">initMoreLess();</SCRIPT>" );
		
		for ( ViewAttachments.AttachmentView view : hiddenViews ) {
			view.writeThumbnailTR( thCounter, true, out, browserInfo );
			thCounter++;
		}
	}
	
	
%>
			<TR><TD></TD></TR>
		</TABLE>
		</DIV>
		</TD>
		<TD style="height: 100%;" width="*" class="viewArea" id="iframeTD">
			<iframe name="viewFrame" id="viewFrame" src="about:blank" width="100%" height="100%" frameborder="0" scrolling="auto" style="margin: 0px; padding: 0px;"></iframe>
		</TD>
	</TR>
</TABLE>
<IMG id="previewImg" \>
<DIV id="previewDoc"></DIV>
</TD></TR></TABLE>

<div id="doctypetool" class="popup" onmouseover="this.style.visibility = 'visible';" onmouseout="this.style.visibility = 'hidden';">
	<a href="JavaScript:editDocType()"><script language="JavaScript">getImage("edit", 18, 20, " alt='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_EDIT_ATTACHMENT" ) %>' title='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_EDIT_ATTACHMENT" ) %>' style='vertical-align: middle;'");</script></a>
	<a href="JavaScript:deleteDocType()"><script language="JavaScript">getImage("delete", 18, 20, " alt='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_ATTACHMENT_NO_CAPITALIZE" ) %>' title='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_ATTACHMENT_NO_CAPITALIZE" ) %>' style='vertical-align: middle;'");</script></a>
	<span id="doctypelabel"></span>
</div>

<FORM name="doctypeForm" action="editAttachment.jsp" target="viewFrame">
  <INPUT TYPE="HIDDEN" NAME="cStudy" VALUE="<%= Helper.htmlEncode( sourceStudy ) %>"/>
  <INPUT TYPE="HIDDEN" NAME="cAttName" id='doctypeAttName'/>
  <INPUT TYPE="HIDDEN" NAME="cAttType" id='doctypeAttType'/>
<% if ( orderNum != null ) { %>
  <INPUT TYPE="HIDDEN" NAME="cOrderNum" VALUE="<%= Helper.htmlEncode( orderNum ) %>"/>
<% } %>
  <INPUT TYPE="HIDDEN" NAME="cPACSOrder" VALUE="<%= isPACSorder %>"/>
</FORM>

<FORM name="doctypeDeleteForm" action="deleteAttachment.jsp" target="viewFrame">
 <INPUT TYPE="HIDDEN" NAME="cStudy" VALUE="<%= Helper.htmlEncode( sourceStudy ) %>"/>
  <INPUT TYPE="HIDDEN" NAME="cAttName" id='doctypeAttName'/>
  <INPUT TYPE="HIDDEN" NAME="cAttType" id='doctypeAttType'/>
<% if ( orderNum != null ) { %>
  <INPUT TYPE="HIDDEN" NAME="cOrderNum" VALUE="<%= Helper.htmlEncode( orderNum ) %>"/>
<% } %>
  <INPUT TYPE="HIDDEN" NAME="cPACSOrder" VALUE="<%= isPACSorder %>"/>
</FORM>
	
</BODY>
</HTML>
