<%--
 * Component: cases
 *
 * Description:
 *    Returns the report for a study in a processable form for the viewer.
 *
 * Parameters:
 * 
 *    study : study instance uid of the study
 *    lock  : lock mode (defaults to 'lock', can also be 'breaklock')
 *
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.util.*,
			imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*, imagemed.repohandler.*,
			imagemed.http.rmi.RMISubstitute,

			com.erad.pacs.common.interfaces.result.WorklistResult,
			com.erad.pacs.modules.gwt.session.right.PacsRight,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			com.erad.pacs.common.interfaces.AkacFacade,

			com.erad.rmisubstitute.call.singlestudy.ParseReportCall,
			com.erad.rmisubstitute.param.StudyLockMode"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );

	Syslog logger = new Syslog( "getrep", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );

	String parStudy = request.getParameter("study");

	// Check if study is accessible to the user
	WorklistResult wlr = WorklistToolbox.staticGetWLR( sess, parStudy );
	if( !wlr.isInAccessList( parStudy ) ) {
		Helper.DEBUG( "Inaccessible prior NORIGHT sent to viewer" );
		response.setHeader( "IMLock","NORIGHT" );
		response.sendError( HttpServletResponse.SC_NOT_FOUND, "No rights" );
		return;
	}

	// Translate Link Study UID to Source Study UID
	parStudy = StudyToolbox.getSourceStudyDB( parStudy );

	String parLock = request.getParameter("lock");
	if (parLock == null)
		parLock = "Lock";

	if (!ReportToolbox.checkUserAgent(request.getHeader( "user-agent" ), response))
		return;

	boolean bRight = sess.getRights().hasAnyOf( PacsRight.Edit, PacsRight.Report, PacsRight.SetStatus, PacsRight.Transcribe );

	ParseReportCall reportCall = new ParseReportCall( ParseReportCall.Mode.AS_IS, parStudy, true );
	StudyLockMode lockMode = null;
	if ( bRight ) {
		if ("Lock".equals( parLock ) ) {
			lockMode = StudyLockMode.LOCK; 
		}
		else if ( "Break".equals( parLock ) ) {
			lockMode = StudyLockMode.BREAKANDLOCK; 
		}
	}
	else {
		response.setHeader( "IMLock", "NORIGHT");
	}
	reportCall.checkModified( 30000, lockMode );
	reportCall.setIncludeDictation( "true".equals( request.getParameter( "embedded_sound" ) ) );

	ParseReportCall.Result result = RMISubstitute.invoke( sess, reportCall );

	String lockId = null;
	if ( result.getLockResult() != null ) {
		IMLock.lockResToResponseHeaders( result.getLockResult(), response );
		lockId = result.getLockResult().m_lockID;
	}
	ParseReportCall.ErrorCode exitCode = result.getExitCode();
	if ( exitCode == ParseReportCall.ErrorCode.INVALID_VERSION ) {
		out.println("INVALID REPORT VERSION");
	}
	else if ( exitCode == ParseReportCall.ErrorCode.ERROR ) {
		response.setContentType( "text/plain" );
		response.setContentLength( 0 );
	}
	else {
		if ( exitCode == ParseReportCall.ErrorCode.MODIFIED ) {
			response.setHeader( "IMReport","MODIFIED" );
			if ( lockId != null ) {
				AkacFacade.unlockStudy( sess, parStudy, IMLock.getLockIDFromRequest( sess, request, null ) );
			}
		}
		response.setContentType( "text/plain" );
		response.setContentLength( result.getUnprocessedReport().length() );

		out.print( result.getUnprocessedReport() );
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}%>
