// add missing (and missed) string functionality
if ( typeof String.prototype.trim != 'function' ) {
	String.prototype.trim = function() {
		var res = this.replace( /^[\s\xA0]+/, "" ).replace( /[\s\xA0]+$/, "" );
		return res;
	};
}

if ( typeof String.prototype.startsWith != 'function' ) {
	String.prototype.startsWith = function( str ) {
		return this.slice( 0, str.length ) == str;
	};
}

if ( typeof String.prototype.endsWith != 'function' ) {
	String.prototype.endsWith = function( str ) {
		return str.length==0 || this.slice( -str.length ) == str;
	};
}

// and an array function too
if ( typeof Array.indexOf != 'function' ) {
	Array.prototype.indexOf = function( obj ) {
		for ( var i = 0; i < this.length; i++ ) {
			if ( this[ i ] == obj ) {
				return i;
			}
		}
		return -1;
	};
};

var isRefreshing = false;


function xmlhttpnew() {
	var xmlhttp = false;
	/* @cc_on @ */
	/*
	 * @if (@_jscript_version >= 5) // JScript gives us Conditional compilation,
	 * we can cope with old IE versions. // and security blocked creation of the
	 * objects. try { xmlhttp = new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {
	 * try { xmlhttp = new ActiveXObject("Microsoft.XMLHTTP"); } catch (E) {
	 * xmlhttp = false; } } @end @
	 */
	if ( !xmlhttp && typeof XMLHttpRequest != 'undefined' ) {
		try {
			xmlhttp = new XMLHttpRequest();
		}
		catch ( e ) {
			xmlhttp = false;
		}
	}
	if ( !xmlhttp && window.createRequest ) {
		try {
			xmlhttp = window.createRequest();
		}
		catch ( e ) {
			xmlhttp = false;
		}
	}
	return xmlhttp;
}

var popupXmlHttp = xmlhttpnew();

function jsPopup( url, title, waitfor, refreshAfter ) {
	if ( !waitfor ) {
		waitfor = false;
	}
	else {
		waitfor = true;
	}
	if ( !popupXmlHttp ) {
		window.open( url, title ? title : 'JsPopup', 'menubar=no,location=no,resizable=no,scrollbars=no,status=no,left=5000,top=5000,screenX=1,screenY=1,width=1,height=1' );
	}
	else {
		popupXmlHttp.open( 'GET', url, !waitfor );
		popupXmlHttp.send( null );
	}
	if ( refreshAfter ) {
		location.reload( true );
	}
}


function IMpopupIfNotRefresh( link, title, width, height ) {
	if( isRefreshing ) {
		return;
	}
	return IMpopup( link, title, width, height );
}


function IMpopup( link, title, width, height ) {
	if ( !width ) {
		width = 400;
	}
	if ( !height ) {
		height = 540;
	}
	newwin = window.open( link, title, 'menubar=no,location=no,resizable=yes,scrollbars=yes,status=yes,width=' + width + ',height=' + height );
	if ( window.focus ) {
		newwin.focus();
	}
	return newwin;
}

// Popup window for the help pages
function IMpopupHelp( link, title ) {
	window.open( link, title, 'menubar=no,location=no,resizable=yes,scrollbars=yes,status=yes,width=900,height=540' );
}


//Open a popup window at the center of the screen
//options must end with ',' if not empty
function IMpopupCenter( url, win, width, height, options ) {
	var left = ( screen.width / 2 ) - ( width / 2 );
	var top = ( screen.height / 2 ) - ( height / 2 );
	options += 'fullscreen=no,top=' + top + ',left=' + left + ',width=' + width + ',height=' + height;
	return window.open( url, win, options );
}



// Open a popup window at the same position and width + height as parent
// options must end with ',' if not empty
function IMpopupSame( url, win, options ) {
	var winX = (document.all)?window.screenLeft:window.screenX;
	var winY = (document.all)?window.screenTop:window.screenY;
	
	var winW = 630, winH = 460;
	
	if (document.body && document.body.offsetWidth) {
		winW = document.body.offsetWidth;
		winH = document.body.offsetHeight;
	}
	if (document.compatMode=='CSS1Compat' &&
		document.documentElement &&
	    document.documentElement.offsetWidth ) {
		winW = document.documentElement.offsetWidth;
		winH = document.documentElement.offsetHeight;
	}
	if (window.innerWidth && window.innerHeight) {
		winW = window.innerWidth;
		winH = window.innerHeight;
	}
	if (window.outerWidth && window.outerHeight) {
		winW = window.outerWidth;
		winH = window.outerHeight;
	}
	
	options += 'fullscreen=no,top=' + winY + ',left=' + winX + ',width=' + winW + ',height=' + winH;
	return window.open( url, win, options );
};


function IMgetContent( url ) {
	popupXmlHttp.open( 'GET', url, false );
	popupXmlHttp.send( null );
	if ( popupXmlHttp.readyState == 4 || popupXmlHttp.readyState == "complete" ) {
		var allData = new String( popupXmlHttp.responseText ).trim();
		if ( allData.substring( 0, 4 ) == "OK: " ) {
			return {
			  code : 0,
			  text : allData.substring( 4 )
			};
		}
		return {
		  code : 2,
		  text : "Server returned error: " + allData
		};
	}

	var respText = "Getting content failed [" + popupXmlHttp.status + ": " + popupXmlHttp.statusText;
	return {
	  code : 1,
	  text : respText
	};
}

/**
 * Submits a HTML DOM Form via AJAX call. If AJAX is not supported, the form will be submitted to a pop-up window
 * 
 * @param formElem the HTML DOM Form to be submitted
 * @param winName name of the popup window for the case AJAX is not suppported
 */
function jsSubmit( formElem, winName ) {
	if ( !popupXmlHttp ) {
		var wname = winName ? winName : 'JsSubmit';
		window.open( "", wname, 'menubar=no,location=no,resizable=no,scrollbars=no,status=no,left=5000,top=5000,screenX=1,screenY=1,width=1,height=1' );
		formElem.target = winName;
		formElem.submit();
	}
	else {
		popupXmlHttp.open( 'POST', formElem.action, true );
		popupXmlHttp.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded' );
		popupXmlHttp.send( getquerystring( formElem ) );
	}
}

/**
 * sends a post request synchronously and returns the response
 * 
 * @param URL url of the page to be called
 * @param params parameters string (like "par1=val1&par2=val2", property names and values escaped if needed)
 * 
 * @return object containing two members: code: 0 -> success, 1 -> http error, 2 -> page reported error
 */
function jsPost( URL, params ) {

	if ( !popupXmlHttp ) {
		var respText = "Getting content failed [ xmlHttp object missing]";
		return {
		  code : 1,
		  text : respText
		};
	}
	popupXmlHttp.open( 'POST', URL, false );
	popupXmlHttp.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded' );
	popupXmlHttp.send( params );
	if ( popupXmlHttp.readyState == 4 || popupXmlHttp.readyState == "complete" ) {
		var allData = new String( popupXmlHttp.responseText ).trim();
		if ( allData.substring( 0, 4 ) == "OK: " ) {
			return {
			  code : 0,
			  text : allData.substring( 4 )
			};
		}
		return {
		  code : 2,
		  text : "Server returned error: " + allData
		};
	}
	var respText = "Getting content failed [" + popupXmlHttp.status + ": " + popupXmlHttp.statusText;
	return {
	  code : 1,
	  text : respText
	};
}

/**
 * Constructs query string from the value of the elements in a HTML DOM Form to submit the form using AJAX
 * 
 * @param formElem the HTML DOM Form to be submited
 * 
 * @return query string to be used to issue an HTTP request
 */
function getquerystring( formElem ) {

	var qstr = "";

	function GetElemValue( name, value ) {
		qstr += ( qstr.length > 0 ? "&" : "" ) + escape( name ).replace( /\+/g, "%2B" ) + "=" + escape( value ? value : "" ).replace( /\+/g, "%2B" );
		//+ escape(value ? value : "").replace(/\n/g, "%0D");
	}

	var elemArray = formElem.elements;

	for ( var i = 0; i < elemArray.length; i++ ) {
		var element = elemArray[ i ];
		var elemType = element.type.toUpperCase();
		var elemName = element.name;

		if ( elemName ) {
			if ( elemType == "TEXT" || elemType == "TEXTAREA" || elemType == "PASSWORD" || elemType == "BUTTON" || elemType == "RESET" || elemType == "SUBMIT" || elemType == "FILE" || elemType == "IMAGE" || elemType == "HIDDEN" ) {
				GetElemValue( elemName, element.value );
			}
			else if ( elemType == "CHECKBOX" && element.checked ) {
				GetElemValue( elemName, element.value ? element.value : "On" );
			}
			else if ( elemType == "RADIO" && element.checked ) {
				GetElemValue( elemName, element.value );
			}
			else if ( elemType.indexOf( "SELECT" ) != -1 ) {
				for ( var j = 0; j < element.options.length; j++ ) {
					var option = element.options[ j ];
					if ( option.selected )
						GetElemValue( elemName, option.value ? option.value : option.text );
				}
			}
		}
	}

	return qstr;
}

/**
 * Shows dropdown menu for download desired version (bitness) of viewer.
 */
function showBitnessDropdownDiv( elem, defaultValue ) {
	var toolDiv = getelementbyid( 'bitnesshovermenu' );
	toolDiv.style.top = ( calcElementTop( elem ) + elem.offsetHeight ) + 'px';
	toolDiv.style.left = ( calcElementLeft( elem ) + 3 ) + 'px';
	var defaultLinkElement = getLinkElementByContent( toolDiv, defaultValue );
	if( (typeof(defaultLinkElement) != "undefined") && (defaultLinkElement != null) ) {
		defaultLinkElement.id = "defaultitemsel";
	}
	toolDiv.style.visibility = "visible";
}

/**
 * Get the first link element which has content equals to <code>linkContent</code>.
 */
function getLinkElementByContent( parentElem, linkContent) {
	var resLink;
	var menulinks = parentElem.getElementsByTagName("a");
	for ( var i =0; i < menulinks.length; i++ ) {
		if ( menulinks[i].innerHTML == linkContent ) {
			resLink = menulinks[i];
            break;
        }
	}
	return resLink;
}

/**
 * Hides dropdown menu for download desired version (bitness) of viewer.
 */
function hideBitnessDropdownDiv() {
	var toolDiv = getelementbyid( 'bitnesshovermenu' );
	var defaultLinkElement = getelementbyid( 'defaultitemsel' );
	if( (typeof(defaultLinkElement) != "undefined") && (defaultLinkElement != null) ) {
		defaultLinkElement.id = "defaultitem";
	}
	toolDiv.style.visibility = "hidden";
}

/**
 * Get chosen viewer.
 * @param bitness the viewer's bitness
 */
function getViewer( bitness ) {
	var downloadViewerUrl = getelementbyid( 'cDownloadViewerUrl' ).value;
	if ( ( bitness == "32" ) || ( bitness == "64" ) ) {
		window.location.replace( downloadViewerUrl.concat("?cBitness=").concat(bitness));
	} else {
		window.location.replace( downloadViewerUrl );
	}
}
