<%--
 * Component: cases
 *
 * Description:
 *  Interface for locking/unlocking studies used by the viewer and remote dotcom servers.
 *
 * Parameters:
 *
 *   cStudy        Study Instance UID
 *   cOp           Lock operation: Lock, Break, CheckLock, IsLocked, Unlock (= default), None
 *   cClose        true - indicates the study is being closed in the viewer
 *                    in case of cClose=true only Unlock and None are the valid lock operations
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade.StudyLockOper"%>
<%@page import="com.erad.pacs.toolbox.ClassesKeystoreParam"%>
<%@page import="com.erad.pacs.toolbox.LoginServiceToolbox"%>
<%@page import="com.erad.rmisubstitute.param.RmiLockResult"%>
<%@page import="com.erad.pacs.services.usermanager.service.tomcat.Sessita"%>
<%@page import="com.erad.pacs.modules.gwt.exception.LockException"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.util.*,java.sql.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%>
<%
	StudyLockOper lockOper = StudyLockOper.fromStr( request.getParameter( "cOp" ), StudyLockOper.UNLOCK );
	String parStudy = request.getParameter( "cStudy" );
	boolean isClose = "true".equals( request.getParameter( "cClose" ) );

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = null;
	
	try {
		sess = userManager.getSessitaSessionNoSessParCheck( request, response );
	} catch (SessionException ex) {
		if ( lockOper == StudyLockOper.UNLOCK ){
			//create a new session for unlock
			sess = LoginServiceToolbox.getSystemSession( new ClassesKeystoreParam() );
		} else {
			throw ex;
		}
	}
	

	Syslog logger = new Syslog( "lockstudy.jsp", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	logger.syslog( Syslog.LOG_DEBUG, parStudy + " " + sess.getSessionId(  ) + " cOp=" + lockOper.m_label );
	if ( null == parStudy ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
		response.setHeader( "IMLock", "FAILED" );
%>FAILED<%return;
	}

	if ( isClose ) {
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "close" );
		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId(  ) );
		logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );

		try ( ResultSet rs = IMEnv.getDB().prepareStatement( "select * from Dcstudy WHERE STYIUID='" + parStudy + "'" ).executeQuery() ) {
			if ( rs.next() ) {
				logEntry.setField( OperLogEntry.FIELD.PNAME, rs.getString( "PNAME" ) );
				logEntry.setField( OperLogEntry.FIELD.MODALITY, rs.getString( "MODALITY" ) );
				logEntry.setField( OperLogEntry.FIELD.PID, rs.getString( "PID" ) );
				logEntry.setField( OperLogEntry.FIELD.ACCNO, rs.getString( "ACCNO" ) );
				logEntry.setField( OperLogEntry.FIELD.STUDYDATE, rs.getString( "THEDATETIME" ) );
				logEntry.setField( OperLogEntry.FIELD.INSTITUTION, rs.getString( "INSTNAME" ) );
				logEntry.setField( OperLogEntry.FIELD.STUDYDESCR, rs.getString( "STYDESCR" ) );
			}
		}
		catch ( SQLException sqlEx ) {
			logger.syslog( Syslog.LOG_ERR, Helper.throwable2String( sqlEx ) );
		}
		logEntry.log( sess, "lockstudy", 0, Syslog.LOG_INFO );
	}

	if ( lockOper == StudyLockOper.UNLOCK ) {
		try {
			AkacFacade.unlockStudy( sess, parStudy, IMLock.getLockIDFromRequest( sess, request, null ) );
			out.println( "OK" );
			return;
		} 
		catch (LockException le) {
			logger.syslog( Syslog.LOG_DEBUG, "Unlock failed: "+ Helper.toString( le ) );
		}
	} 
	else {
		logger.syslog( Syslog.LOG_DEBUG, "Unhandled lock operation: "+ lockOper.m_label );
	}
	
	response.setHeader( "IMLock", "FAILED" );
	%>FAILED<%

	if ( true )
		return;
%>