<%-- 
 * Component: cases
 *
 * Description:
 *   Quick View Window to show a DICOM image
 
 *   Quick View Window has got two parts (frames).
 *   The top is the quick view.
 *   The bottom contains DICOM dump links.
 *
 * Params:
 *    cFileName - File Name of the object to show
 *    cI          Frame Number within the object
 *    cX          Maximum X size
 *    cY          Maximum Y size
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@
	page errorPage="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.Helper,imagemed.types.*,java.sql.*,imagemed.imsession.*,imagemed.jsputil.RedirectToolbox"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );

	boolean hasDumpRight = sess.getRights().hasRight( PacsRight.Dump );

	String cI = request.getParameter( "cI" );
	String cX = request.getParameter( "cX" );
	String cY = request.getParameter( "cY" );
	String type = request.getParameter( "type" );

	Statement st = IMEnv.getDB().createStatement();
	String fileName = request.getParameter( "cFile" );
	String study = request.getParameter( "cStudy" );
	
	String redirHost = RedirectToolbox.getRedirectForStudy( sess, study );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/cases/qvwin.jsp?" + RedirectToolbox.getRedirectParams( sess, request );
		response.sendRedirect( redirURL );
		return;
	}
	
	String stStr = "SELECT PNAME FROM Dcstudy WHERE STYIUID='" + Helper.sqlEncode( study ) + "'";
	String pName = null;
	try ( ResultSet res = st.executeQuery( stStr ) ) {
		res.next();
		pName = res.getString( "PNAME" );
	}

	String patientName = IMType.getTypeFor( "PN" ).display( sess, pName );

	String frameSetRows = hasDumpRight ? "*,48" : "*";
	
%><HEAD>
<TITLE><%=patientName%></title>
</head>

<FRAMESET rows="<%=frameSetRows%>" frameborder=no frameborder="0" border=0 framespacing=0>

<FRAME src="qvwintop.jsp?study=<%= study %>&fileName=<%= fileName %>&cI=<%= cI %>&cX=<%= cX %>&cY=<%= cY %>&type=<%= type %>"
		noresize marginwidth=0 marginheight=0>

<%
	if ( hasDumpRight ) {
%>

<FRAME src="qvwinbot.jsp?cStudy=<%= study %>&cFname=<%= fileName %>&pName=<%= Helper.URLEncodeUTF8( patientName ) %>"
		noresize marginwidth=0 marginheight=0>
<%
	}
%>

</frameset>