<%--
 * Component: cases
 *
 * Description:
 *  WEB interface for setting study status from viewer without writing report.
 *
 * Parameters:
 *
 *   study      Study Instance UID
 *   unlock     Unlock study after saving report: true (= default), false
 *
 *   qe_STAT    Study Status (0, 20, 50, 60, 80, 100)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%>
<%@page import="com.erad.rmisubstitute.call.singlestudy.CommitStudyCall.CommitResult"%>
<%@page import="com.erad.rmisubstitute.call.singlestudy.CommitStudyCall"%>
<%@page import="com.erad.rmisubstitute.call.singlestudy.CommitStudyCall.EditMode"%>
<%@page import="com.erad.rmisubstitute.call.singlestudy.CommitStudyCall.CommitRequest"%>
<%@page import="imagemed.http.rmi.RMISubstitute"%>
<%@page import="com.erad.pacs.modules.gwt.exception.EPException"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="java.util.Map.Entry"%>
<%@page import="java.sql.SQLException"%>
<%@page import="imagemed.exception.IMException"%>
<%@page import="imagemed.dcprocessing.EditStudy"%>
<%@
	page import="imagemed.util.*, com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.imsession.*, java.util.*, imagemed.jsputil.ProxyToolbox"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );

	MultipartRequest mp = new MultipartRequest(request,IMEnvBase.getEnv("TMP"));

	String parStudy   = mp.getParameter("study");
	String parUnlock  = mp.getParameter("unlock"); // default true
	String parLockID  = mp.getParameter( "lockid" );
	String parStatus  = mp.getParameter("qe_STAT");

	boolean bUnlock = ! "false".equals(parUnlock);

	Syslog logger = new Syslog("setStatus", 0, IMEnvBase.getEnv("LOG_OPER_FACILITY"));
	logger.syslog(Syslog.LOG_DEBUG,parStudy + " " + sess.getSessionId(  ));
	
/*
  // Uncomment this section to log parameters in debug log

  for (Enumeration e = request.getParameterNames(); e.hasMoreElements();)
  {
    String parName = (String) e.nextElement();
    String parVals[] = request.getParameterValues(parName);
    if (parVals == null) continue;
    for (int i = 0 ; i < parVals.length ; i++)
      logger.syslog(Syslog.LOG_DEBUG,"PARAM " + parName + " = [" + parVals[i] + "]");
  }
*/

/*	is.bCheckHttpsAndRedirect = false;
	if ( ! ProxyToolbox.init(is, mp, logger) ) {
		if (!is.regOK()) {
			return;
		}
	}*/

	if (null == parStudy) {
		logger.syslog(Syslog.LOG_DEBUG,"Study is null");
		%>FAILED<%return;
	}

	// reg.jspi sets is.regID to null
/*	if (is.regID == null)
		is.setRegID( request.getHeader("IMRegID") );*/

	if (!sess.getRights(  ).hasRight( PacsRight.Report ) || !sess.getRights( ).hasRight( PacsRight.SetStatus ) ) {
		logger.syslog(Syslog.LOG_DEBUG,"No Rights");
		response.setHeader("IMAuthentication","norights");%>FAILED<%return;
	}

/*	if ( ProxyToolbox.checkAndProxy(is, parStudy, mp, false) ) {
		logger.syslog(Syslog.LOG_DEBUG,"checkAndProxy is true");

		if (!is.bRegNotNeeded) {
			// Status change request was sent to this server by the user
			// We need to log
			Syslog operLogger = new Syslog("setStatus", 0, IMEnvBase.getEnv("LOG_OPER_FACILITY"));
			String logMsg = "Status:=\"" + parStatus + "\"";

			OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "edit" );
			logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
			logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );
			logEntry.setField( OperLogEntry.FIELD.CHANGES, logMsg );
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, "changed on owner device" );
			logEntry.log( operLogger, Syslog.LOG_INFO );

//			operLogger.syslog(Syslog.LOG_INFO,"INFO STUDY edit " + logUser.replace(' ', '_') + " - " + parStudy + " - - - - - - - - " + logMsg + " changed_on_owner_device");
		}

		return;
	}*/

/*	if (is.sessionVariables == null)
		is.sessionVariables = new Properties();

	is.sessionVariables.setProperty("unlock", "" + bUnlock);*/

	String editFields[] = { "STAT" };

	HashMap<String, String> newValues = new HashMap<String, String>();
	
	newValues.put( "STAT", parStatus );
	
	CommitRequest cr = new CommitRequest(parStudy, EditMode.DEFAULT, null, newValues);
	cr.setLockId( parLockID );
	cr.setUnlock( "true".equals( parUnlock ) );
	
	try { 
		CommitStudyCall csc = new CommitStudyCall(cr);
		CommitResult cRes = RMISubstitute.invoke( sess, csc );
		
		if (cRes.m_resultPrp == null) {
			logger.syslog(Syslog.LOG_DEBUG,"editStudy.edit() returned null --> FAILED");
// 			for ( Entry<String, String[]> entry : rspHeaders.entrySet(  ) ) {
// 				String name = entry.getKey(  );
// 				response.setHeader(name,entry.getValue(  )[0]);
// 			}
			%>FAILED<%
			return;
		}
	} catch(  Exception e ) {
		e.printStackTrace(  );
		throw e;
	}

	logger.syslog(Syslog.LOG_DEBUG,"return OK.");
%>OK<%

	if (true)
		return;

%>
