<%@page import="java.net.InetAddress"%>
<%@page import="com.erad.pacs.services.usermanager.client.Envelope"%>
<%@page import="java.security.PrivateKey"%>
<%@page import="java.security.KeyStore.PrivateKeyEntry"%>
<%@page import="com.erad.pacs.toolbox.KeystoreToolbox"%>
<%@page import="cases.ActionjspKeystoreParam"%>
<%@page import="com.erad.pacs.modules.gwt.descriptors.usermanager.LoginWithKeyModule"%>
<%@page import="java.nio.file.StandardCopyOption"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.nio.file.Files"%>
<%@page import="java.nio.file.Paths"%>
<%@page import="java.nio.file.Path"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.dotcom.DotcomConfig"%><%--
* Component: cases
*
* Description:
*  Interface for uploading a study (to the given HUB), extracting it and importing to the worklist
*
* Parameters (multipart):
*
*   cFile         The content of the new DICOM object
*
* Last Updated     : $Author$
* Update Date Time : $Date$
* RCS File Name    : $RCSfile$
* RCS Revision     : $Revision$
* Locked by        : $Locker$
* Symbolic name    : $Name$
* State            : $State$
*
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!
	// "true" means : return from this jsp, either because of redircet or because of problem 
	boolean checkTargethubAndRedir( Session sess, String targetHUB, HttpServletResponse response, JspWriter out ) {
		try {
			Helper.DEBUG( "Checking targethub:" + targetHUB );
			if( targetHUB != null && !"".equals( targetHUB ) && !targetHUB.equals( DotcomConfig.selfId() ) ) {
				//redirect, multi params are not needed, they will be included in writeMultipartBodyTo
				String device = DotcomConfig.getConfig().getServerNameTowards( targetHUB );
				if( device != null ) {
					String idBase = RedirectToolbox.getURL( device, sess.getClientAddress().getHostAddress(), null );
					if( idBase != null && !"".equals( idBase ) ) {
						StringBuilder sb = new StringBuilder( idBase );
						sb.append( "/cases/uploadImportStudy.jsp" );
						if( sess.getSessionId() != null ) {
							sb.append( "?sessionid=" + sess.getSessionId() );
						}
						Helper.DEBUG( "uploadImportStudy redirected to:" + sb.toString() );
						response.sendRedirect( sb.toString() );
						return true;
					}
				}
			}
		}
		catch( Throwable th ) {
			Helper.defaultCatch( th );
			try {
				out.print( "FAILED" );
			}
			catch( Throwable t2 ) {
				Helper.defaultCatch( t2 );
			}
			return true; // 
		}
	 	return false;
	}
%><%
	Helper.DEBUG( "BUU NEW uploadImportStudy jsp called" );

	Helper.DEBUG( "uploadImportStudy.jsp session id param:" + request.getParameter( "sessionid" ) );
	
/*	
	Enumeration<String> headerNames = request.getHeaderNames();
	while (headerNames.hasMoreElements()) {
		String headerName = headerNames.nextElement();
		String he = request.getHeader( headerName );
		Helper.DEBUG( "upload Header Name:" + headerName + " value:" + he );
	}

	Helper.DEBUG( "upload method:" + request.getMethod(  ) );
	Helper.DEBUG( "upload content type:" + request.getContentType(  ) );
*/
	
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	
	Helper.DEBUG( "BUU uploadImportStudy jsp called (2)" );

	Session sess = userManager.getSessitaSession( request, response );

	boolean isRedirOnly = "true".equals( request.getHeader("RedirectOnly") );

	Helper.DEBUG( "BUU uploadImportStudy jsp called (3), RedirectOnly:" + request.getHeader("RedirectOnly") );

	boolean isV8 = "true".equals( request.getHeader("V8Upload") );
	String targetHUB = request.getHeader("TargetHUB");
	if( checkTargethubAndRedir( sess, targetHUB, response, out ) ) {
		return;
	}
	// this 1st check is when in v8 we got target hub from header
	
	if( isRedirOnly ) {
		// if it's a 'dummy' call which is for redirection only, we DON'T parse Multipart here, we arrived to destination, so just give back empty 200
		return;
	}
	
	MultipartRequest mp = new MultipartRequest(request, IMEnvBase.getEnv("TMP"));

	targetHUB = mp.getParameter("cTargetHUB");
	checkTargethubAndRedir( sess, targetHUB, response, out );
	// this 2nd check is when from 72 we got target hub from parameter

	String[] parStudyUIDs = mp.getParameterValues("cGr"); 
	String parFile     = mp.getParameter("cFile");
	//tmp file name will be in it - for 72

	boolean createDicomdir = !"true".equals( mp.getParameter("cDicomdir") ); 

	boolean isCompressedv8 = "true".equals( request.getHeader("Compression") );
		
			
	//ez itten azt jelenti, hogy minden serverre el fogja kuldeni a multipart-ot, de ezzel nem tudunk mit tenni...
	// majd a feltolto egybol oda kuldi, ha tudja...
	
	Helper.DEBUG( "BUU uploadImportStudy after Multipart request, targetHUB:" + targetHUB + "; session ID: " + sess.getSessionId() + "; userid: " + sess.getUser().getUserId() + "; studies: " + Helper.toString( parStudyUIDs ) + "; createDicomdir: " + Helper.toString( createDicomdir ) + "; Compression: " + Helper.toString( isCompressedv8 )  );

	if( checkTargethubAndRedir( sess, targetHUB, response, out ) ) {
		return;
	}
	
	if (!mp.isMultiPart()) {
		Helper.DEBUG( "Not Multipart request" );
		out.print( "FAILED" );
		return;
	}
	else {
		String tmpDirName = IMEnvBase.getEnv( "TMP" ) + "/importstudies." + System.currentTimeMillis();

		try {
			if( !isV8 ) {
				Helper.extractFilesFromZip( parFile, tmpDirName, false );
				DicomDirToolbox.startImporting( sess, parStudyUIDs, tmpDirName, true );
				Helper.DEBUG( "return value:'FILE:" + parFile + "'" );
				out.print( "FILE:" + parFile );
			}
			else {
				Path dirPathObj = Paths.get( tmpDirName );
				Files.createDirectories( dirPathObj );
				// move files into its original subdir on its original name for the DICOMDIR (also changing \ to /)
				// DICOMDIR is also included in the files
				Enumeration<String> parNames = mp.getParameterNames();
				while( parNames.hasMoreElements() ) {
					String par = parNames.nextElement();
					Helper.DEBUG( "parametername: " + par + " value:" + mp.getParameter( par ) );
					if( par.startsWith( "cFile" ) ) {
						String fileName = mp.getParameter( par );  // saved file name
						String origName = mp.getFileNameFor( par );
						Helper.DEBUG( "filename: " + fileName + " origname: " + origName );
						if( fileName != null && origName != null ) {
							origName = origName.replace( '\\', '/' );
							int lastDirPos = origName.lastIndexOf( '/' );
							if( lastDirPos != -1 ) {
								String actDirName = tmpDirName + "/" + origName.substring( 0, lastDirPos );
								Helper.DEBUG( "actDirName: " + actDirName );
								Path dirPathObjAct = Paths.get( actDirName );
								Files.createDirectories( dirPathObjAct );
							}
							if( isCompressedv8 ) {
								Helper.extractFileFromDeflate( fileName, tmpDirName + "/" + origName );								
							}
							else {
								Path src = Paths.get( fileName ); // fileName is the absolute path.
								Path dst = Paths.get( tmpDirName + "/" + origName );
								Files.move( src, dst, StandardCopyOption.ATOMIC_MOVE );
								Helper.DEBUG( "file moved from " + fileName + " to " + tmpDirName + "/" + origName );
							}
						}
					}
				}
				
				if( createDicomdir ) {
					List<String> cmd = new ArrayList<String>();
					cmd.add( IMEnvBase.getEnv( "CD_HOME" ) + "/createdicomdir.sh" );
					cmd.add( tmpDirName ); 
					Helper.DEBUG( "dicomdir creation command is " + Helper.toString( cmd ) );
					RunCommandResult result = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ) );
					String dicomdirFile = tmpDirName + "/"; 
					if ( result.getExitCode() == 0 ) {
						dicomdirFile += "DICOMDIR";
						Helper.DEBUG( "dicomdir created:" + dicomdirFile );
					}
					else {
						Helper.ERRORLOG( "dicomdir creation problem:" + result.getError() );
					}
				}
				
				DicomDirToolbox.startImporting( sess, parStudyUIDs, tmpDirName, true );     
				
	//			Helper.removeDirectoryRecursively( tmpDirName );
				out.print( "OK" );
				Helper.DEBUG( "return value:'OK'" );
			}
		}
		catch( Throwable th ) {
			Helper.ERRORLOG( "Exception in media import extracting (to " + tmpDirName + ") :" + Helper.throwable2String( th ) );
			out.print( "FAILED" );
		}

		
		return;
	}
%>