#!/bin/sh
#
# Component: cases
#
# Description:
#  OBSOLETE [7.0]
#  Stoles study ownership from child server.
#
# Usage:
#   stoleownership.sh <study>
#
#   <study> : Stole ownership of this study
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh


# if stoleownership.sh is called directly:
# run as a task instead
if [ `basename $0` = "stoleownership.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi


LOGGER="/usr/bin/logger"
TAG="stoleownership.sh[$$]"

Study=$1

# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	OwnerDevice=""
	. $CASES_HOME/includeStorestate.shi "$Study"

	echo "$OwnerDevice"
}


run_() # override run_ method
{
	[ -z "$Study" ] && return 125

	$TASKD_HOME/runjavacmd -c "0 cases.StealOwnership -s \"$Study\"" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
} # run_()


# override cleanup_
cleanup_()
{
	$TASKD_HOME/runjavacmd -c "cleanup cases.StealOwnership -s \"$Study\"" -p "$JAVA_SERVER_PORT"
}

# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print cases.StealOwnership -s \"$Study\"" -p "$JAVA_SERVER_PORT"
}

