#!/bin/sh
#
# Component: cd
#
# Description:
#  Collect information on DICOMDIR content for Archive/Media page
#
# Arguments:
#   $1 : Path to the DICOMDIR file
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$


. $HOME/etc/setenv.sh


$DCVIEWER_HOME/herelo -d $1 | awk '
function printrec() {
	print date "_" time, pnam, pid, accno, mod, desc, numSers, numObjs, uid;
	uid = "";
	numSers = 0;
	numObjs = 0; 
}
 
BEGIN {
	uid = id = accno = desc = date = time = mod = pnam = pid = "";
	numSers = 0;
	numObjs = 0;
}

{
	tag = $1;
	vr = $2;

	i = index($0,"(");
	if (i != 0) {
		val =substr($0, i+15);
		if (val == "Empty Value")
			val = "\t.\t"; 

		#   val="test string with percent (%) and plus (+) characters";
		gsub("%", "%25", val);
		gsub("+", "%2B", val);
		gsub(" ", "+", val);
		gsub("\t", "%09", val);

		if (tag == "(0004,1430)") {
			if (val == "PATIENT" || val == "STUDY") {
				if (uid != "")
					printrec();
			}
			else if (val == "SERIES") {
				numSers++;
			}
			else if (val == "IMAGE") {
				numObjs++;
			}
		}
		else if (tag == "(0010,0010)") {
			pnam = val;
		}
		else if (tag == "(0020,000d)") {
			uid = val;
		}
		else if (tag == "(0020,0010)") {
			id = val;
		}
		else if (tag == "(0008,0050)") {
			accno = val;
		}
		else if (tag == "(0008,1030)") {
			desc = val;
		}
		else if (tag == "(0008,0020)") {
			date = val;
		}
		else if (tag == "(0008,0030)") {
			time = val;
		}
		else if (tag == "(0008,0060)" && val != "SR" ) {
			mod = val;
		}
		else if (tag == "(0010,0010)") {
			pnam = val;
		}
		else if (tag == "(0010,0020)") {
			pid = val;
		}
	}
}
 
END {
   if (uid != "")
		printrec();
}'
