#!/bin/gawk -f
#
# Component: dotcom
#
# Description:
#    Checks if there is a 'Database' device in the dotcom.
#    Prints the device id of the Database device if found
#
# Usage:
#    $1 - Dotcom configuration file ($CONF/dotcom.jcfg)
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#


BEGIN {
	isDotcomDevice = 0;
	deviceName = "";
}

( $1 == "<DotcomDevice>" ) {
	isDotcomDevice = 1;
	deviceName = "";
	next;
}

( $1 == "</DotcomDevice>" ) {
	isDotcomDevice = 0;
	deviceName = "";
	next;
}

( $1 == "<ID>") {
	if (isDotcomDevice && deviceName == "")
		deviceName = $2
	next;
}

( $1 == "<ProcessMode>" && $2 == "Database") {
	if (deviceName != "")
		print deviceName;
}
