<%--
 * Component: dotcom
 *
 * Collects device information for dotcom configuration
 * Retrieves deviceid for a peer device (child or parent).
 *
 * This page is used by the peer to figure out self device id in existing dotcom systems.
 *
 * No Parameters:
 *
--%><%@page
	import="com.erad.pacs.connector.Connector,
		com.erad.pacs.services.usermanager.client.Session,
		com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
		imagemed.imsession.*,
		imagemed.jsputil.*,
		imagemed.dotcom.*,
		java.util.*,
		java.io.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	String devId = request.getParameter( "except" );
	String mode = request.getParameter( "mode" );
	boolean recollect = !"returnCurrent".equals( mode );
	boolean needSession = true;
	try {
		// accept from parent(P)/child(C)/backupTarget(B)/backupSource(S)/Media Source(M)/Media PACS(A)
		Properties devPrp = DotcomToolbox.checkIPAddress( request.getRemoteAddr(), "PCBSMA" );

		if ( devPrp != null ) {
			needSession = false;
			devId = devPrp.getProperty( "ID" );
			String type = devPrp.getProperty( "TYPE" );
			recollect = "C".equals( type ) || "P".equals( type );
		}
	}
	catch ( Throwable th ) {
	}
	if (needSession) {
		UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
		Session sess = userManager.getSessitaSession( request, response );
	}

	if ( !recollect ) {
		// request from outside the dotcom:
		// do not recollect, but return current config
		DotcomConfig dcfg = DotcomConfig.getConfig();
		String selfDeviceId = dcfg.getSelfId();
		Map<String, Device> devices = dcfg.getDevices();
		DotcomDevice.writeRemoteConfig( out, selfDeviceId, devices );
		out.flush();
		return;
	}


	Throwable collectException = null;
	DotcomConfig dcfg = new DotcomConfig();
	try {
		dcfg = DotcomConfig.reCollect( response.getWriter(), devId );	
	}
	catch ( Throwable th ) {
		imagemed.util.Helper.ERRORLOG( "dotcom.getconfig.jsp Exception:" + imagemed.util.Helper.throwable2String( th ) );
		collectException = th;
	}

	if ( !( devId != null || "true".equals( request.getParameter( "serialize" ) ) ) ) {
%><HTML><HEAD><TITLE>Dotcom Cfg</TITLE></HEAD><BODY><PRE>
<%
		if ( collectException != null ) {
			out.println( "Collect Exception: " + collectException.toString() );
			collectException.printStackTrace( new PrintWriter( out ) );
		}
		out.println( "collect returns: " + ( dcfg != null ) );
		out.println( "devId: " + devId );
		try {
			dcfg.print( out );
		}
		catch ( Throwable th ) {
			out.println( "Exception: " + th.toString() );
		}

		Vector<String> archiveDevices = dcfg.getArchiveServers();
		out.println( "Archive devices:" );
		if ( archiveDevices != null ) {
			for ( Iterator<String> i = archiveDevices.iterator(); i.hasNext(); ) {
				out.println( "     " + i.next() );
			}
		}


		DotcomDevice selfDevice = dcfg.getSelfDevice();
		if ( null != selfDevice ) {
			out.println( "---------------\n" );
			out.println( selfDevice.getDebug() );
			out.println( "</pre></body></html>" );
		}

%></PRE></BODY></HTML><%
	}
	else if ( collectException != null ) {
		response.setStatus( HttpServletResponse.SC_INTERNAL_SERVER_ERROR );
		out.println( collectException.toString() );
		collectException.printStackTrace( new PrintWriter( out ) );
	}
%>
