<%--
 * Component: dotcom
 *
 * Description:
 *  Proliferates files in dotcom
 *
--%><%@
	page import="java.io.*, java.nio.file.Files, java.nio.file.attribute.FileTime, java.text.SimpleDateFormat, java.util.*,
		imagemed.imsession.*, imagemed.jsputil.DotcomToolbox, imagemed.util.*,
		imagemed.dotcom.mixedmode.hl7.*,
		com.erad.pacs.services.usermanager.client.*,
		com.erad.pacs.connector.Connector,
		com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
		com.erad.pacs.modules.gwt.descriptors.usermanager.LoginWithKeyModule,
		dotcom.ProliferatejspKeystoreParam,
		com.erad.pacs.toolbox.LoginServiceToolbox"
		
 
%><%!
 
	// XXX: In theory Files.setLastModifiedTime() could be used to pass even nanosecs,
	// but currently it does not work (requires POSIX 2008 compliance at native side)
	// To support nanosecs FILE_TIME_FORMAT should also be updated for a better precision 

	// Should be the same as in dotcom.Upload() (duplicated only due to code visibility issues)
	static final SimpleDateFormat FILE_TIME_FORMAT = new SimpleDateFormat( "yyyyMMddHHmmss.SSSZ" );


	long parseTime(String strTime) {
		long returnValue = 0;
		try {
			int year = Integer.parseInt(strTime.substring(0,4));
			int month = Integer.parseInt(strTime.substring(4,6)) - 1;
			int day = Integer.parseInt(strTime.substring(6,8));
			int hour = Integer.parseInt(strTime.substring(8,10));
			int min = Integer.parseInt(strTime.substring(10,12));
			int sec = Integer.parseInt(strTime.substring(12,14));

			returnValue = new GregorianCalendar(year,month,day,hour,min,sec).getTime().getTime();
		}
		catch (Throwable th) {
		}

		return returnValue == 0 ? System.currentTimeMillis() : returnValue;
	}


	String[] createCmd(String strScript, String strParams, String filename) {
		if (strParams == null) {
			String[] strCmdArray = new String[3];
			strCmdArray[0] = strScript;
			strCmdArray[1] = "-f";
			strCmdArray[2] = filename;
			return strCmdArray;
		}

		StringTokenizer st = new StringTokenizer(Helper.replace(strParams,"\\n","\n"),"\n");
		String[] strCmdArray = new String[st.countTokens() + 3];
		strCmdArray[0] = strScript;
		strCmdArray[1] = "-f";
		strCmdArray[2] = filename;
		int i = 3;

		while (st.hasMoreTokens()) {
			strCmdArray[i++] = st.nextToken();
		}

		return strCmdArray;
	}

%><%
	MultipartParser mpParams = new MultipartParser(request, IMEnvBase.getEnv("TMP"));

	String parDestFileName = mpParams.getParameter("cName");
	String parTmpFileName  = mpParams.getParameter("cFile");
	String parFileTime     = mpParams.getParameter("cTime");
	String parOldFileTime  = mpParams.getParameter("cDate"); // XXX: deprecated
	String parScript       = mpParams.getParameter("cScript");
	String parParams       = mpParams.getParameter("cParams");

	String strDestFileName = parDestFileName;
	if (parDestFileName != null && !parDestFileName.startsWith("/"))
		strDestFileName = IMEnvBase.getEnv("HOME") + "/" + parDestFileName;

	String strScript = parScript;
	if (parScript != null && !parScript.startsWith("/"))
		strScript = IMEnvBase.getEnv("HOME") + "/" + parScript;

	
	Properties peerPrp = null;
	try {
		peerPrp = DotcomToolbox.checkClient( null, request.getRemoteAddr(), "PCS", false );
	}
	catch ( Throwable th ) {
	}

	if ( peerPrp == null ) {
		Helper.ERRORLOG( "prolifarate.jsp called from a non-neighbour device." );
		return;
	}
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	
	Session sess = null;
	try {
		Envelope envelope = LoginServiceToolbox.loginService( userManager, new ProliferatejspKeystoreParam(), null );
		sess = userManager.checkForRmiSubstitute( envelope );
	}
	catch ( Exception e ) {
		Helper.ERRORLOG( "Login of user " + peerPrp.getProperty( "ID" ) + " failed: " + Helper.throwable2String( e ) );
		return;
	}

	String devID = peerPrp.getProperty("ID");

	String exceptParam = devID == null ? "-x\\n" + request.getRemoteAddr() : "-x\\n" + devID;
	if (parParams == null)
		parParams = exceptParam;
	else
		parParams = parParams + "\\n" + exceptParam;

	boolean bSucceed = false;
	boolean bNewer = false;
	boolean bSaved = false;

	File fileTmp = null;
	File fileDest = null;
	File fileSave = File.createTempFile("proliferate","save", new File(IMEnvBase.getEnv("TMP")));

	Syslog logger = new Syslog("proliferate.jsp", 0, IMEnvBase.getEnv("LOG_FACILITY"));
	logger.syslog(Syslog.LOG_INFO, strDestFileName + " received " +
				strDestFileName + " " + parTmpFileName + " " + parFileTime + " " + strScript
				+ " " + parParams);

	try {
		fileDest = new File(strDestFileName);
		if (parTmpFileName == null)
			throw new Throwable("strFileNotFound");

		fileTmp = new File(parTmpFileName);
		String strFileNotFound = "[File wasn't found by client]";
		byte[] buffer = new byte[strFileNotFound.length()];

		FileInputStream fisTmp = new FileInputStream(fileTmp);
		int nRead = fisTmp.read(buffer);
		fisTmp.close();

		if (nRead > 0) { // File is not empty
			if (strFileNotFound.startsWith(new String(buffer,0,nRead))) {
				fileSave.delete();
				throw new Throwable("strFileNotFound");
			}
		}

		// check if fileDest time is newer than parFileTime
		long lFileTime = 0; // System.currentTimeMillis();
		try {
			lFileTime = FILE_TIME_FORMAT.parse( parFileTime ).getTime();
		}
		catch ( Throwable th ) {
		}
		if ( lFileTime == 0 ) {
			// XXX: fall back to old file format (to be deprecated)
			// falls back to current time when there is no old style date
			lFileTime = parseTime( parOldFileTime );
		}

		if (fileDest.exists() && lFileTime <= fileDest.lastModified()) {
			bNewer = true;
			fileSave.delete();
			throw new Throwable("Newer");
		}

		if (fileDest.exists()) {
			bSaved = ( Helper.renameToNotThrowsException( fileDest, fileSave ) );
		}
		
		int pos = strDestFileName.lastIndexOf("/");
		if (pos != -1) {
			try {
				String destDirName = strDestFileName.substring(0,pos);
				File destDir = new File(destDirName);
				if (!destDir.exists())
					destDir.mkdirs();
			}
			catch(Throwable th) {
			}
		}

		fileTmp.setLastModified(lFileTime);
		if ( Helper.renameToNotThrowsException( fileTmp, fileDest ) ) {
			if ( strScript != null ) {
				String[] scriptPath = strScript.split( "/" );
				if ( scriptPath.length > 0 && "processPBHL7Message.sh".equals( scriptPath[ scriptPath.length -1 ] ) ) {
					Message msg = null;
					try {
						FileInputStream is = new FileInputStream( fileDest );
						PbHl7Reader reader = new PbHl7Reader( new InputStreamReader( is, "ISO-8859-1" ) );
						msg = Message.readMessage( reader );
					}
					catch( Exception ex ) {
						Helper.ERRORLOG( "Reading/Parsing incoming HL7 message " + fileDest + " failed: " + Helper.throwable2String( ex ) );
						fileDest.delete();
						throw new Throwable("Script failed");
					}
					fileDest.delete();
					try {
						msg.process( sess );
					}
					catch( Exception ex ) {
						Helper.ERRORLOG( "Processing incoming HL7[" + msg.getType() + "] message " + fileDest + " failed: " + Helper.throwable2String( ex ) );
						throw new Throwable("Script failed");
					}
				}
				else {
					String cmd[] = createCmd(strScript, parParams, strDestFileName);
					String env[] = new String[1];
					env[0] = "HOME=" + IMEnvBase.getEnv("HOME");

					String strCmd = "";
					for (int i = 0; i < cmd.length; i++)
						strCmd = strCmd + " | " + cmd[i];

					logger.syslog(Syslog.LOG_INFO,strDestFileName + " run command: " + strCmd);

					RunCommandResult res = Helper.runCommandEx(cmd,env);
					if ( res.getExitCode() == 2 ) {
						// A newer file was found
						bNewer = true;
					}
					else if ( res.getExitCode() != 0 ) {
						throw new Throwable("Script failed");
					}
				}
			}
			bSucceed = true;
			fileSave.delete();
		}
	}
	catch (Throwable th) {
		if ("strFileNotFound".equals(th.getMessage())) {
			try {
				Helper.writeTextFile(strDestFileName, null);

				fileSave.delete();

				String cmd[] = createCmd(strScript, parParams, strDestFileName);
				String env[] = new String[1];
				env[0] = "HOME=" + IMEnvBase.getEnv("HOME");

				String strCmd = "";
				for (int i = 0; i < cmd.length; i++)
					strCmd = strCmd + " | " + cmd[i];

				logger.syslog(Syslog.LOG_INFO,strDestFileName + " run command: " + strCmd);

				RunCommandResult res = Helper.runCommandEx(cmd,env);
				if ( res.getExitCode() == 2 ) {
					// A newer file was found
					bNewer = true;
				}
				else if ( res.getExitCode() != 0 ) {
					throw new Throwable("Script failed");
				}
				bSucceed = true;
			}
			catch(Throwable th2) {
			}
		}
		else {
			Helper.ERRORLOG( "proliferate.jsp storing " + fileDest + " Exception: " + Helper.throwable2String( th ) );
		}
	}

	if (!bSucceed) {
		if (bSaved){
			Helper.renameToNotThrowsException( fileSave, fileDest );
		}
		if (fileTmp != null)
			fileTmp.delete();
	}

%><%= bSucceed ? "OK" : (bNewer ? "NEWER" : "FAILED") %>
