<%--
 * Component: imadmin
 *
 * Description:
 *  Show and set Merge settings
 *
 *  @param parOp         Operation to be performed
 *
 *  Possible values for parOp and specific params
 *
 *    merge :         modify merge.cfg
 *      @param r_<colid>   'R' - means correct study data with RIS data
 *      @param c_<colid>   correction mode of the field ('S' - soft, 'H' -hard)
 *      @param e_<colid>   'E' - use RIS data even if empty
 *
 *    set_matching  : modify autocorrection criteria
 *    set_matching2 : modify manual correction criteria
 *      @param m           new correction criteria
 *
 *    add_matching  : add new criterion to autocorrection criteria
 *    add_matching2 : add new criterion to manual correction criteria
 *      @param add         criterion to be added
 *
 *    prior :         modify prior matching criteria
 *      @param pr_list     prior matching fields
 *
 *
 *
--%><%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.modules.gwt.session.BrowserInfo"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="java.io.IOException"%>

<%@page import="com.erad.pacs.toolbox.LogToolbox"%>
<%@page import="com.erad.pacs.services.eventdispatcher.client.descriptors.EventType"%>
<%@page import="com.erad.pacs.services.eventdispatcher.client.descriptors.events.MergeEvent"%>

<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.*, imagemed.imsession.*, com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			java.util.*,java.sql.*,imagemed.jsputil.*, imagemed.dcprocessing.*, imagemed.util.*"

%><%!void showMatching(Session is, IMFieldManagerImpl fm,  String code, String matching, JspWriter out, String[] allFields, boolean isColids ) throws IOException
	{
		out.println("<FORM>\n<TABLE cellpadding=2>");
		int i = 0;
		if(! ("".equals(matching) || matching==null)) {
			ValTokenizer v1 = new ValTokenizer(matching,'\n');
			String mprev=null;
			while(v1.hasMoreTokens()) {
				String m = v1.nextToken();
				ValTokenizer v2 = new ValTokenizer(m,',');
				String fields="";
//				String values="";
				while (v2.hasMoreTokens()) {
					String field = v2.nextToken();
					String name = field;
					if( isColids ) {
						name = fm.getHeaderName( field );					
					}
					else {
						try {
							PreparedStatement st;
							st=IMEnv.getDB().prepareStatement("SELECT COLID FROM Dcfields WHERE DBNAME='"+
									field + "'");
							ResultSet r = st.executeQuery();
							if (r.next())
								name = fm.getHeaderName(r.getString("COLID"));
						}
						catch (SQLException e) {
						}
					}

					fields = ( "".equals(fields)? "" : fields + "+" ) + name;
//					values = ( "".equals(values)? "" : values + "," ) + field;
				}

				out.println("<TR class=BgMedLight><TD>");

				// delete
				ValTokenizer old = new ValTokenizer(matching,'\n');
				String nm = "";
				while (old.hasMoreTokens()) {
					String temp = old.nextToken();
					if (! temp.equals(m)) {
						nm = nm + ("".equals(nm) ? "" : "\n") + temp;
					}
				}
//				String nm = Helper.replace(matching,m+"\n","");
				out.println("<A href=\"merge.jsp?op=set_"+code+"&m="+Helper.URLEncodeUTF8(nm+"\n")+"\">"+
						"<IMG src=\"/cases/art/delete.gif\" border=0></A>");

				// move up
				if (mprev !=null) {
					String up = Helper.replace(matching, mprev+"\n"+m+"\n",m+"\n"+mprev+"\n");
					out.println("<A href=\"merge.jsp?op=set_"+code+"&m="+Helper.URLEncodeUTF8(up)+"\">"+
							"<IMG src=\"/cases/art/up.gif\" border=0></A>");
				}
				mprev = m;

				// the thing
				out.println("</TD><TD>"+fields+"</TD>");

				out.println("</TD></TR>");
				i++;
			}
		}
		out.println("<TR class=BgMedLight><TD>&nbsp;</TD><TD>");

		//{ "PAID", "PANM", "PDOB", "PSEX", "ACCN", "PRST",
		//                         "PHRF", "PHRD", "PHPR", "PHRR" };

		out.println("<TABLE border=0 width=0><TR><TD width=0><SELECT name=add size=6 multiple align=left>");
		for (i=0; i< allFields.length; i++) {
			String name=allFields[i];
			if( isColids ) {
				name = fm.getHeaderName( allFields[i] );
			}
			else {
				try {
					PreparedStatement st;
					st=IMEnv.getDB().prepareStatement("SELECT COLID FROM Dcfields WHERE DBNAME='" + allFields[i] + "'");
					ResultSet r = st.executeQuery();
					if (r.next())
						name = fm.getHeaderName(r.getString("COLID"));
				}
				catch (SQLException e) {
				}
			}
			out.println("<OPTION VALUE=\""+allFields[i]+"\">"+name);
		}
		out.println("</SELECT></TD><TD>");

		out.println("<I><FONT size=-1>" + LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_MESSAGE_MULTIPLE" ) + "<BR><BR></FONT></I>");
		out.println("  <INPUT TYPE=hidden NAME=\"op\" VALUE=\"add_"+code+"\">\n"+
				JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_ADD", "", "" )+"\n </TD></TR></TABLE>");

		out.println("</TD></TR>");
		out.println("</TABLE>\n</FORM>");
	}%><%-- ----- Input Parameter(s) ----- --%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );
		
	String parUser = null;
	Syslog slog = new Syslog( "merge", 0 , IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	Defs casesDefs = new Defs( sess);
			
	String parOp   = request.getParameter( "op" );

	// Apply changes to the merge hard/soft config

	if ( "merge".equals( parOp ) ) {
		/*
			Read the content of merge config and replace editable field values
			with new values. This will keep uneditable (site specific) field
			values.
		*/
		Hashtable<String, MergeFlag> mergeConfig = Merge.readMergeConfig( IMEnvBase.getEnv("CONF") + "/merge.cfg" );
		
		StringBuffer logMerge = new StringBuffer();
		for (Enumeration<?> e = request.getParameterNames(); e.hasMoreElements();) {
			String pname = (String) e.nextElement();
			if (pname.startsWith("r_")) {
				String colid = pname.substring( 2 );

				MergeFlag mf = new MergeFlag();	// Source: Modality

				String source = request.getParameter( pname );

				if ( "R".equals( source ) ) {
					boolean temporary = "true".equals( request.getParameter( "t_" + colid ) );
					boolean useEmpty = "true".equals( request.getParameter( "e_" + colid ) );

					mf.setSource( MergeFlag.Source.RIS );
					mf.setTemporary( temporary );
					mf.setForceEmpty( useEmpty );
				}

				if ( ! mf.equals( mergeConfig.get( colid ) ) ) {
					mergeConfig.put( colid, mf );
					logMerge.append( colid ).append( ":" ).append( mf ).append( ";" );
				}
			}
		} // for parameterNames
		

//		out.println("<PRE>\n"+merge+"</pre>");
		Merge.writeMergeConfig( mergeConfig, IMEnvBase.getEnv( "CONF" ) + "/merge.cfg" );
		
		String LOG_IDENTIFICATION = "Merge_Jsp";
		MergeEvent event = MergeEvent.createSourcesEvent( LOG_IDENTIFICATION, casesDefs.getUser(), sess.getSessionId() );
		event.appendChangedValueText( logMerge.toString() );
		LogToolbox.sendEvent( event );
	}

	// Apply changes to the matching criteria config
	else if ("set_matching".equals(parOp) || "set_matching2".equals(parOp) || 
		"set_deviceMatch".equals(parOp) || "set_procedureMatch".equals(parOp) || "set_patientMatch".equals(parOp) || "set_referrerMatch".equals(parOp) ) {
		String v = request.getParameter("m");
		
		if ("".equals(v))
			v = null;
//		out.println("<PRE>\n"+v+"</pre>");
		Helper.writeTextFile(IMEnvBase.getEnv("CONF")+"/"+ parOp.substring(4) + ".cfg", v);
		if ("set_matching".equals(parOp)) {
			String LOG_IDENTIFICATION = "Merge_Jsp";
			MergeEvent event = MergeEvent.createAutoCorrEvent( LOG_IDENTIFICATION, casesDefs.getUser(), sess.getSessionId() );
			event.appendChangedValueText( v );
			LogToolbox.sendEvent( event );
		}
		else {
			String LOG_IDENTIFICATION = "Merge_Jsp";
			MergeEvent event = MergeEvent.createManualCorrEvent( LOG_IDENTIFICATION, casesDefs.getUser(), sess.getSessionId() );
			event.appendChangedValueText( v );
			LogToolbox.sendEvent( event );
		}
	}
	else if ("add_matching".equals(parOp) || "add_matching2".equals(parOp)  || 
		"add_deviceMatch".equals(parOp) || "add_procedureMatch".equals(parOp) || "add_patientMatch".equals(parOp) || "add_referrerMatch".equals(parOp) ) {
		String v = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/"+ parOp.substring(4) + ".cfg");
		if (v == null) {
			if( "add_deviceMatch".equals(parOp) || "add_procedureMatch".equals(parOp) || "add_patientMatch".equals(parOp) || "add_referrerMatch".equals(parOp) ) {
				v = Helper.readTextFile( IMEnvBase.getEnv("SCHEDULER_HOME") + "/cfg/" + parOp.substring(4) + ".cfg");
			}
			else {
				v = "";
			}
		}

		String add[] = request.getParameterValues("add");
		if (add != null) {
			int i;
			for(i=0;i<add.length; i++)
				v = v + (i == 0 ? "" : ",") + add[i];

			if ("add_matching".equals(parOp)) {
				String LOG_IDENTIFICATION = "Merge_Jsp";
				MergeEvent event = MergeEvent.createAutoCorrEvent( LOG_IDENTIFICATION, casesDefs.getUser(), sess.getSessionId() );
				event.appendChangedValueText( v );
				LogToolbox.sendEvent( event );
			}
			else {
				String LOG_IDENTIFICATION = "Merge_Jsp";
				MergeEvent event = MergeEvent.createManualCorrEvent( LOG_IDENTIFICATION, casesDefs.getUser(), sess.getSessionId() );
				event.appendChangedValueText( v );
				LogToolbox.sendEvent( event );
			}
			v = v + "\n";
		}
//		out.println("<PRE>\n"+v+"</pre>");
		Helper.writeTextFile(IMEnvBase.getEnv("CONF")+"/"+ parOp.substring(4) + ".cfg", v);
	}
	else if ("prior".equals(parOp)) {
		String v = "";
		String pr[] = request.getParameterValues("pr_list");
		if (pr != null) {
			int i;
			for(i=0; i<pr.length; i++) {
				v = v + (i == 0 ? "" : ",") + pr[i];
			}
			String LOG_IDENTIFICATION = "Merge_Jsp";
			MergeEvent event = MergeEvent.createPatientEvent( LOG_IDENTIFICATION, casesDefs.getUser(), sess.getSessionId() );
			event.appendChangedValueText( v );
			LogToolbox.sendEvent( event );
			v = v + "\n";
		}
		v = "# configured by imadmin/merge.jsp\n" + v;
		Helper.writeTextFile(IMEnvBase.getEnv("PRIOR_VAR")+"/prior.cfg", v);
	}

	else if ("changemisc".equals(parOp)) { // misc merge settings changed
		String showfree = request.getParameter("showfree");
		if( showfree == null || "null".equals( showfree ) ) {
			showfree = "";
		}
		IMProperties miscProps = new IMProperties();
		miscProps.setProperty( "showfree", showfree );
		miscProps.recWrite( IMEnvBase.getEnv( "CONF" ) + "/mergemisc.conf" );
	}%><HTML>
<HEAD><TITLE><%=LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_HTMLPAGE_TITLE" )%></TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly(response.getWriter(  ));
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(response.getWriter(  ));
%>
</HEAD>
<BODY>
<%
//	TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicomsrv.jsp", "White");

if (!sess.getRights(  ).hasAdminRight(  )) { //Has no ADMIN RIGHT?%>
%>
<BR>
<CENTER><H3>
<%=LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" )%>
</H3></CENTER></BODY></HTML>
<%
	return;
	}

	String SQLtables[]     = { "Dcstudy", "Dcobject" , "SchedulerPatient", "SchedulerDevice", "SchedulerProcedure", "SchedulerReferrer", "DcstudyDcm" }; //,""
	IMFieldManagerImpl fm = new IMFieldManagerImpl("Dcfields", "Dctypes", SQLtables);

	Hashtable<String, MergeFlag> mergeConfig = Merge.readMergeConfig( IMEnvBase.getEnv("CONF") + "/merge.cfg" );

	String matching  = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/matching.cfg");
	String matching2 = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/matching2.cfg");
	
	DualPropsConfigReader mergeMiscCfg = new DualPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/mergemisc.conf", IMEnvBase.getEnv( "CASES_HOME" ) + "/cfg/mergemisc.conf" );
	Properties mergeProps = mergeMiscCfg.getProperties();
	String showFree = mergeProps.getProperty( "showfree", "yes" );
	
	String patientMatch = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/patientMatch.cfg");
	if( patientMatch == null ) {
		patientMatch = Helper.readTextFile(IMEnvBase.getEnv("SCHEDULER_HOME") + "/cfg/patientMatch.cfg");
	}
	String deviceMatch = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/deviceMatch.cfg");
	if( deviceMatch == null ) {
		deviceMatch = Helper.readTextFile(IMEnvBase.getEnv("SCHEDULER_HOME") + "/cfg/deviceMatch.cfg");
	}
	String procedureMatch = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/procedureMatch.cfg");
	if( procedureMatch == null ) {
		procedureMatch = Helper.readTextFile(IMEnvBase.getEnv("SCHEDULER_HOME") + "/cfg/procedureMatch.cfg");
	}
	String referrerMatch = Helper.readTextFile(IMEnvBase.getEnv("CONF")+"/referrerMatch.cfg");
	if( referrerMatch == null ) {
		referrerMatch = Helper.readTextFile(IMEnvBase.getEnv("SCHEDULER_HOME") + "/cfg/referrerMatch.cfg");
	}

%>
<STYLE TYPE="text/css">
	TD.topmost {
		font-family: arial, helvetica, universe, sans-serif;
		vertical-align: top;
		font-size: 10pt;
	}
</STYLE>
<table width="100%" border=1 cellpadding=0 cellspacing=0 class=BgShadow>
	<tr>
		<td>
			<table width="100%" cellpadding=0 cellspacing=0>
				<tr>
					<td>
						<br>
						&nbsp;&nbsp;<font size="4"><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_TITLE" ) %></font>
						<br> &nbsp;
					</td>
					<td align=right>
						<a  onclick="top.parent.evoNavigate('settings:system')"><%= JSHelper.getJsLocalizedButton( "BUTTON_BACK", "BUTTON_NULL", false ) %></a>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
<table width="100%" border=1 cellpadding=0 cellspacing=0 class=BgShadow>
	<tr>
		<td CLASS=topmost align=center valign=top width="50%">
			&nbsp;<H3><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_DEFAULT_CORRECTION_SOURCES" ) %></H3>
			<FORM>
				<TABLE cellpadding=2 class=BgMedLight>
 					<TR>
  					<TD><B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_FIELD" ) %></B></TD>
  					<TD><B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_MODALITY" ) %></B></TD>
  					<TD><B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_RIS" ) %></B></TD>
  					<TD><B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_TEMPORARY" ) %></B></TD>
					<TD><B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_EMPTY" ) %></B></TD>
 					</TR>
<%

	String mergeFields[] = Merge.getMergeFields();

	int i;
	for ( i = 0; i < mergeFields.length; i++ ) {
		String field = mergeFields[ i ];
		String name = IMBaseFieldManagerImpl.staticGetUiName( field );
		String risChecked = "";
		String modChecked = "";
		String tmpChecked = "";
		String emptyChecked = "";

		MergeFlag flag = mergeConfig.get( field );
		if ( flag == null ) {
			flag = new MergeFlag();
		}


		if ( flag.getSource() == MergeFlag.Source.RIS ) {
			risChecked = "checked";
			if ( flag.isTemporary() ) {
				tmpChecked = "checked";
			}
			if ( flag.isForceEmpty() ) {
				emptyChecked = "checked";
			}
		}
		else {
			modChecked = "checked";
		}
%>
  				<TR>
				    <TD><%= name %></TD>
				    <TD align=center><INPUT type=radio    name="r_<%=field%>" value=M <%= modChecked %> ></TD>
				    <TD align=center><INPUT type=radio    name="r_<%=field%>" value=R <%= risChecked %> ></TD>
				    <TD align=center><INPUT type=checkbox name="t_<%=field%>" value=true <%= tmpChecked %> ></TD>
				    <TD align=center><INPUT type=checkbox name="e_<%=field%>" value=true <%= emptyChecked %> ></TD>
				  </TR>
<%
  }
%>
				  <TR>
					  <TD colspan=5 align=right>
					   <INPUT TYPE=hidden NAME="op" VALUE="merge">
						<%= JSHelper.getJsInputLocalizedButton(new BrowserInfo(), "BUTTON_CHANGE", "", "") %>
					  </TD>
				  </TR>
				</TABLE>
			</FORM>
			
			<br><br><H3><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_SHOW_HIDE_FREETEXT_TITLE" ) %></H3>
			<TABLE cellpadding=2 class=BgMedLight>
				<FORM>
 					<TR>
 						<TD>
 							<%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_SHOW_HIDE_FREETEXT" ) %>
 						</TD>
 						<TD>
 							<SELECT name="showfree">
<%
								out.println( DicomSrvToolbox.getOption( "yes", LocalizedMessage.getSimpleMessage( "termYES" ), showFree ) );
								out.println( DicomSrvToolbox.getOption( "no", LocalizedMessage.getSimpleMessage( "termNO" ), showFree ) );
%> 							
							</SELECT> 						
 						</TD>
 						<TD>
 							&nbsp;
					   	<INPUT TYPE=hidden NAME="op" VALUE="changemisc">
							<%= JSHelper.getJsInputLocalizedButton(new BrowserInfo(), "BUTTON_CHANGE", "", "") %>
 						</TD>
 					</TR>	
				</FORM>
			</TABLE>			
		</td>
		<td CLASS=topmost align=center valign=top>
			&nbsp;<H3><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_CORRECTION_LIST_CRITERIA" ) %></H3>
			<% showMatching( sess, fm, "matching2", matching2, out, Matching.FIELDS, false ); %>
		</td>
	</tr>
	<tr>
		<td CLASS=topmost align=center valign=top>
			&nbsp;<H3><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_AUTOCORRECTION_MATCHING_CRITERIA" ) %></H3>
			<% showMatching( sess, fm, "matching", matching, out, Matching.FIELDS, false ); %>
		</td>
		<td CLASS=topmost align=center valign=top>
			&nbsp;<H3><%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_PATIENT_MATCHING_CRITERIA" ) %></H3>
			<TABLE cellpadding=2>
				<FORM>
				 <TR class=BgMedLight>
				  <TD>
				   <TABLE border=0 width=0>
				   	<TR>
				   		<TD width=0>
   							<SELECT name=pr_list size=6 multiple align=left>"
<%

	LinkedHashMap<String, Boolean> patienMatchingFields = new LinkedHashMap<String, Boolean>();
	patienMatchingFields.put( "PAID", Boolean.FALSE );
	patienMatchingFields.put( "PANM", Boolean.FALSE );
	patienMatchingFields.put( "PDOB", Boolean.FALSE );
	patienMatchingFields.put( "PSEX", Boolean.FALSE );

	String relevFields[] = RelevantResultImpl.getRelevFields();
	for ( String field : relevFields ) {
		patienMatchingFields.put( field, Boolean.TRUE );
	}

	for ( String field : patienMatchingFields.keySet() ) {
		String name = fm.getHeaderName( field );	String fp[] = { "PAID", "PANM", "PDOB", "PSEX" };
		String sel = "";
		if ( patienMatchingFields.get( field ) ) {
			sel = "selected";
		}
		out.println( "  <OPTION value=\"" + field + "\" " + sel + ">" + name + "\n" );	}
%>
	  						</SELECT>
				  		</TD>
				  		<TD>
   	  					<I>
				   	  		<FONT size=-1>
		   		  				<%= LocalizedMessage.getSimpleMessage( "IMADMIN_MERGE_MESSAGE_MULTIPLE" ) %>
   	  							<BR><BR>
				   	  		</FONT>
   	  					</I>
				  			<INPUT TYPE=hidden NAME="op" VALUE="prior">
							<%= JSHelper.getJsInputLocalizedButton(new BrowserInfo(), "BUTTON_CHANGE", "", "") %>
<%--  <INPUT TYPE=image SRC="/cases/art/change.gif" border=0>--%>
				  		</TD>
				  	</TR>
				   </TABLE>
				 	</TD>
				 </TR>
				</FORM>
			</TABLE>
		</td>
	</tr>
</table>

</BODY>
</HTML>
