#!/bin/sh
#
# proliferate database row 
# -t <tablename> 
# -i <idfieldname> 
# -v <id value>
# -d  if row has to be deleted
# (made from proliferateuser.sh, taking it as example)
#
# Last Updated     : $Author: pzahorcsek $
# Update Date Time : $Date: 2014/04/10 14:55:27 $
# RCS File Name    : $RCSfile: proliferatedb.sh,v $
# RCS Revision     : $Revision: 1.2 $
# Locked by        : $Locker:  $
# Symbolic name    : $Name:  $
# State            : $State: Exp $

. $HOME/etc/setenv.sh

TABLE=""
ID=""
VALUE=""
DELETE="false"
DEFAULTORIENTATION="all"
ORIENTATION=""

while getopts 't:i:v:do:' OPT; do
	case $OPT in
	i) ID="$OPTARG" ;;
	t) TABLE="$OPTARG" ;;
	v) VALUE="$OPTARG" ;;
	d) DELETE="true" ;;
	o) ORIENTATION="$OPTARG" ;;
	*) usage_ "Invalid_Parameter:$OPT" ;;
	esac   
done

if [ "$ORIENTATION" != "all" -a "$ORIENTATION" != "up" -a "$ORIENTATION" != "down" -a "$ORIENTATION" != "backup" -a "$ORIENTATION" != "all-backup" ] ; then
	ORIENTATION="$DEFAULTORIENTATION"
fi

if [ -z "$ID" ] || [ -z "$TABLE" ] || [ -z "$VALUE" ] || [ -z "$ORIENTATION" ] ; then
	exit 1
fi	

QUERY_FILE="$TMP/${TABLE}_insert_update_or_delete.$VALUE"

if [ "true" = "$DELETE" ] ; then
	# DELETE QUERY
	echo "delete from $TABLE where $ID='$VALUE';" > ${QUERY_FILE}	
	[ $? -ne 0 ] && exit 1
else	
	# INSERT QUERY
	
	${MYSQL_HOME}/bin/mysqldump $DBNAME $TABLE -c -t --where="$ID='$VALUE'" > ${QUERY_FILE}
	[ $? -ne 0 ] && exit 1
	
	# UPDATE QUERY 
	
	echo "select * from $TABLE where $ID='$VALUE';" | \
	$MYSQL_HOME/bin/mysql -E $DBNAME | tail -n +2 |\
	gawk -vFS=":" -vID="$ID" -vTABLE="$TABLE" -vs="'" ' \
		BEGIN { \
			update = ""; \
			id = ""; \
		} \
		{ \
			column = $1; \
			gsub(" ","",column); \
			if (column == ID) { \
				id = substr($2,2); \
			} \
			val = substr($2,2); \
			sep = s; \
			if (val == "NULL") \
				sep = ""; \
			gsub(s,"\\" s, val); \
			update = update  ","  $1 "=" sep val sep ; \
			sep = s; \
		} \
		END { \
			print "update " TABLE " set " substr(update,2) " where " ID "=" sep id sep ";" \
		}' >> ${QUERY_FILE}
	
	[ $? -ne 0 ] && exit 1

fi

# PROLIFERATE

$TASKD_HOME/createtaskfileapp -p "PROLIFERATE" -t "sh" -c "${DOTCOM_HOME}/proliferate.sh -f ${QUERY_FILE} -d "$ORIENTATION" -r ${DOTCOM_HOME}/applyquery.sh"

[ $? -ne 0 ] && exit 1

exit 0
		