<%--
 ** Component: scheduler
 **
 ** Description:
 **   this jsp page is intended to be used by type-ahead radiologist macro
 **   
 **
 ** Parameters: 
 **
 **  @param filter		filter to restrict result
 **  @param size		number of results to return; default is 10
 **
--%><%@page errorPage ="../main/exceptionHandler.jsp"

%><%@page import="java.util.List"

%><%@page import="com.erad.pacs.connector.Connector"
%><%@page import="com.erad.pacs.services.usermanager.client.Session"
%><%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"
%><%@page import="imagemed.jsputil.GetpbsToolbox"
%><%@page import="imagemed.types.string.IMTypePN"
%><%@page import="imagemed.util.JSHelper"
%><%@page import="imagemed.util.Helper"

%><%
	String filter = request.getParameter("filter");
	String sSize = request.getParameter("size");
	boolean skipLocationIssues = "true".equals( request.getParameter("skipLocationIssues") ); 
	boolean usesLocation = "true".equals( request.getParameter("usesLocation") );

	int size = 10;
	try {
		size = Integer.parseInt(sSize);
	} catch (NumberFormatException ex) {
		Helper.ERRORLOG( "Parameter size (" + sSize + ") could not be converted to number! Falling back to default size." );
	}

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );
	List<String[]> result = GetpbsToolbox.getMatchingRadiologists( sess.getEnvelope(), filter, size, skipLocationIssues, usesLocation );
	
	if (result == null || result.size() == 0) {
		out.print("FAILED (No record)");
	} else if (result.size() > size ) {
		out.print("LIMITED");
	} else {
		out.print("OK");
	}
	
	for (String[] record : result) {
		// 0: unique option id (= radiologist id), 1: option value (=user database name), 2: option display text (user display name)
		// index 2 no longer contains IMTypePANM.displayListText() because Edit report page uses it's own dislay name
		String displayName = IMTypePN.displayOrdinaryText( sess, record[1] );
		String[] array = {record[0], record[1], displayName};
		//Helper.ERRORLOG("TESZT json:" + JSHelper.toJSON( array ));		
		out.print( "\n" + JSHelper.toJSON( array ) );
	}
	
	if (true) {
		return;
	}%>