<%--
 ** Component: scheduler
 **
 ** Uploads an attachment and saves it in the attachment repository 
 **
 ** 	@param userfile			the Multipart containing the attachment
 **												the original filename must be xxx_0, xxx_1, xxx_2, etc. in case of multiple pages
 **   @param cStudyIUID  (volt id						id of the entity to attach to (order ID, ...) IT WILL BE STUDY UID noew (we are PACSOrder) )
 **   @param name					name of this attachment
 **	  @param cPDF					if "true" attachment(s) will be converted to PDF (default: false)
 **	  @param numpages			the number of total pages (1,2, ...) this attachment contains
 **	  @param cDocType 		the document type (display name, not inner ID!) of the attachment
 **
 **   @return							"FILE:" + name of the uploaded file, if successful
 **
--%><%@page import="imagemed.dotcom.DotcomConfig"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,imagemed.exception.*"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%@page import="java.io.File"%><%@
	page import="imagemed.http.tabs.TabBean"%><%@page import="com.erad.pacs.app.broker.table.internals.TableImpl"%><%

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );
	
	String targetHUB = request.getHeader("TargetHUB");
	Helper.DEBUG( "ScanUpload", "targetHUB in header:" + targetHUB );

	if( targetHUB != null && !"".equals( targetHUB ) && !targetHUB.equals( DotcomConfig.selfId() ) ) {
		//redirect, multi params are not needed, they will be included in writeMultipartBodyTo
		String device = DotcomConfig.getConfig().getServerNameTowards( targetHUB );
		if( device != null ) {
			String idBase = RedirectToolbox.getURL( device, sess.getClientAddress().getHostAddress(), null );
			if( idBase != null && !"".equals( idBase ) ) {
				StringBuilder sb = new StringBuilder( idBase );
				sb.append( "/scheduler/upload.jsp" );
				if( sess.getSessionId() != null ) {
					sb.append( "?sessionid=" + sess.getSessionId() );
				}
				Helper.DEBUG( "ScanUpload", "upload.jsp redirected to:" + sb.toString() );
				response.sendRedirect( sb.toString() );
				return;
			}
		}
	}

	
%><%@page import="java.util.Properties"%><%@page import="imagemed.scheduler.SchedulerInterface"%><%
	response.setContentType("text/plain");
//DEBUG
/*
	ServletInputStream isstream = request.getInputStream();
	File fLoginDir = new File(IMEnv.getEnv("ATTACHMENT_DATA"));
	File fVidFile = File.createTempFile(""+System.currentTimeMillis(),".sca", fLoginDir );
	FileOutputStream ostream = new FileOutputStream(fVidFile);
	byte buffer[] = new byte[2048];
	int nRead;

	while (-1 != (nRead = isstream.read(buffer))) {
				ostream.write(buffer, 0, nRead);
	}

	isstream.close();
	ostream.close();
	
	if( true )
		return;
*/	
	

	String tmpFileName;
	String type = "order"; // for PACSORder, it's called 'order' in the repo
	String studyUID;
	String name;
	String genaFileName = null;
	String numPages = null;
	boolean isPDF = false;
	String docType = null; //this will be the displayed name of the doctype!!! not the inner ID
	
	boolean isUploadedPdf = false;
	
	MultipartRequest mp = new MultipartRequest( request, AttachmentManager.getTempDir() );
	tmpFileName = mp.getParameter("userfile");

	
	Helper.DEBUG( "ScanUpload", "Not Overwrite, tmpfilename:" + tmpFileName );

	studyUID = mp.getParameter("cStudyIUID");
	name = mp.getParameter("name");
	numPages = mp.getParameter("numpages");
	
	Helper.DEBUG( "ScanUpload", "Numpages:" + numPages );

	genaFileName = mp.getFileNameFor("userfile");
	isPDF = "true".equals( mp.getParameter("cPDF") );
	docType = mp.getParameter("cDocType");
	
	if( docType != null ) {
		docType = AttachmentManager.getDoctypeIDFromDisplayName( docType );
	}
	
	if( tmpFileName == null ) {
		out.println( "No temporary file created in upload!");
		return;
	}

	Helper.DEBUG( "ScanUpload - BiiiBuuu", "Type:" + type + " ID:" + studyUID + " Name:" + name + " genaFileName: " + genaFileName + " numpages: " + numPages + "Doctype:" + docType + (isPDF ? " isPDF" : "" ) );
	
	boolean logging = AttachmentManager.isLastPage( numPages, genaFileName );
	
	Properties logFields = new Properties();
	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "Scan/Upload" );
	Syslog operLogger = new Syslog( "upload.jsp", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	if( logging ) {
		logFields.setProperty( "0LAC", "Scan/Upload" );
		if( studyUID != null ) {
				logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
				logEntry.setBasicStudyFields(sess, studyUID );
		}
	}
	
	File tmpFile = new File( tmpFileName );
	if( !tmpFile.exists() ) {
		Helper.DEBUG( "ScanUpload", "Tmp File Not Found!" );
		out.println( "Tmp File Not Found!");
		return;
	}
	else {
		Helper.DEBUG( "ScanUpload", "Tmp File Found!" );
		if( tmpFile.length() == 0 ) {
			Helper.DEBUG( "ScanUpload", "Tmp File is empty!" );
		}
		
		if( name != null && !"".equals(name) ) {
			Helper.DEBUG( "createScanned", "type-id-name:" + name );
			
			AttachmentManager.createScanned( genaFileName, type, studyUID, name, tmpFileName, true, true, numPages, false, isPDF, docType );
			AttachmentManager.setAttachmentCounts( studyUID, true );
			if( logging ) {
				String info = "Attachment name:" + name + " , type:" + ( isPDF ? "PDF": "JPG" ) + " , No. of pages:" + numPages;
				logEntry.setField( OperLogEntry.FIELD.MESSAGE, info );
			}
		}
		else {
			Helper.DEBUG( "ScanUpload", "No name found!" );
			out.println( "No name found!");
			return;
		}
	}
	Helper.DEBUG( "ScanUpload", "before logging" );
	if( logging ) {
		logEntry.log(sess, operLogger, Syslog.LOG_INFO );
	}
	Helper.DEBUG( "ScanUpload", "after logging" );
	Helper.DEBUG( "upload succesful, output:'FILE:" + tmpFileName + "'" );
	out.println( "FILE:" + tmpFileName ); //means OK 
%>	